<!--
- book display component
- @copyright VTM Corp 2016
-->
<book>
  <div class="row">
    <div class="col s8">
      <b><input type="text" name="title" class="tooltipped book_title" onkeyup={ changeTitle }
        data-position="bottom" data-tooltip={ getLangText("tt_book_title") }></b>
    </div>
  </div>
  <div class="book-info">
    <div class="row">
      <div class="book-thumbnail">
        <img class="tooltipped" src={ getDataPath("img/")+bookDetailData.thumbnail_url }
          alt="book_thumbnail"  data-position="bottom" data-tooltip={ getLangText("tt_book_image") }/>
        <a href="#" class="tooltipped btn-float" onclick={ uploadThumbnail }
          data-position="bottom" data-tooltip={ getLangText("tt_book_image_upload") }>
          <i class="material-icons">cloud_upload</i></a>
        <a href="#" class="tooltipped btn-float" show={ bookDetailData.thumbnail_url!="no-thumbnail.png" } onclick={ clearThumbnail }
          data-position="bottom" data-tooltip={ getLangText("tt_book_image_clear") }>
          <i class="material-icons red-text">clear</i></a>
      </div>
    </div>
    <div class="row">
      <div class="tooltipped book-description-wrapper description show-scroll"  ondblclick={ editDescription }
        data-position="bottom" data-tooltip={ getLangText("tt_book_description") }>
        <rtf-content content={ formatText(bookDetailData.description) } ></rtf-content>
        <div class="overlay-panel"></div>
      </div>
    </div>
  </div>
  <script>
    var self = this;
    self.bookDetailData = null;

    self.on("update",function(){
      if(self.opts.type == "book"){
        self.bookDetailData = self.opts.book
      }
    })
    self.on("updated", function(){
      self.initTooltip()
      if(self.bookDetailData)
        $(".book_title").val(self.bookDetailData.name)

    })
    formatText(text){
      return text?text:"";
    }
    changeTitle(e){
      self.bookDetailData.name = $(e.currentTarget).val();
      RiotControl.trigger("book_update", self.bookDetailData);
      e.preventUpdate = true
    }
    changeDescription(e){
      self.bookDetailData.description = $(e.currentTarget).val();
      RiotControl.trigger("book_update", self.bookDetailData);
    }
    uploadThumbnail(){
      RiotControl.one("image_uploaded",function(image_file){
        self.bookDetailData.thumbnail_url = image_file
        RiotControl.trigger("book_update", self.bookDetailData)
        self.update()
      })
      RiotControl.trigger('image_upload')
    }
    clearThumbnail(){
      self.bookDetailData.thumbnail_url = "no-thumbnail.png";
      RiotControl.trigger("book_update", self.bookDetailData);
    }
    editDescription(e){
      var descElm = $(e.currentTarget)
      if(descElm.length > 0){
        if(descElm.is(".description")){
          type = "description"
          content= self.bookDetailData.description
        }
        self.updateDescription(type, content)
      }
    }
    updateDescription(type, content){
      RiotControl.one("richtext_updated",function(data){
        if(data.type == "description"){
          self.bookDetailData.description = data.content
          RiotControl.trigger('book_update',self.bookDetailData)
          self.update()
        }
      })
      self.mountDialog("richtext-dialog",{content:content, type: type})
    }
  </script>
</book>
