<!--
- dialog for select card to add to story
- @copyright VTM Corp 2016
-->
<card-add-dialog>
  <div id="card-add-dialog" class="modal right-sheet">
    <div class="row">
      <div class="col s12">
        <h5 class="left">{ getLangText("add_card_header") }</h5>
    </div>
    <div class="row">
      <div class="col s6">
        <div class="list-card-type tooltipped" data-position="bottom" data-tooltip={ getLangText("tt_add_card_card_type") }>
          <div each={ card_type,card_type_index in card_types }
            class={ card-type-item:true, active: card_type_index==parent.selectingCardIndex }
            onclick={ selectCard } ondblclick={ addCardOnDbclick }>
            <card-type data={ card_type }></card-type>
            <div class="title">{ card_type.name }</div>
          </div>
        </div>
      </div>
      <div class="col s6">
        <ul class="collection list-category z-depth-1 white tooltipped" data-position="bottom" data-tooltip={ getLangText("tt_add_card_cate") }>
          <li each={ category,category_index in categories } class={ collection-item:true, active:category_index==parent.selectingCategoryIndex }
            onclick={ selectCategory }>{ category.name }</li>
        </ul>
      </div>
    </div>
    <div class="row">
      <br/>
      <div class="col s12 left-align">
        <a href="#" class="tooltipped modal-action modal-close waves-effect waves-green btn-flat blue-text btn-add-card-type" show={ card_types.length > 0 } onclick={ addCard }
           data-position="top" data-tooltip={ getLangText("tt_add_card_add") }>
          { getLangText("add_card") }
        </a>
      </div>
    </div>
  </div>
  <script>
    var self = this
    self.card_types = null
    self.selectingCardIndex = 0
    self.categories = null
    self.selectingCategoryIndex = 0
    self.type = self.opts.type

    self.on("mount", function(){
      self.initTooltip()
      $("#card-add-dialog").openModal({
        complete: function() {
          self.unmountDialog();
        }
      });
      RiotControl.off('categories_got')
      RiotControl.one('categories_got',function(categories){
        if(self.selectingCategoryIndex >= categories.length){
          self.selectingCategoryIndex = categories.length-1
          self.selectingCardIndex = 0
        }
        if(self.selectingCategoryIndex < 0)
          self.selectingCategoryIndex = 0
        self.categories = categories

        self.listenCardTypesGot()
        RiotControl.trigger('card_types_get',self.type, self.categories[self.selectingCategoryIndex]._id)

        self.update()
      })
      RiotControl.trigger('categories_get', self.type)
    })

    listenCardTypesGot(){
      RiotControl.off('card_types_got')
      RiotControl.one('card_types_got',function(card_types){
        self.card_types = card_types
        self.update()
      })
    }
    selectCategory(e){
      self.selectingCategoryIndex = e.item.category_index
      self.selectingCardIndex = 0
      self.listenCardTypesGot()
      RiotControl.trigger('card_types_get',self.type, self.categories[self.selectingCategoryIndex]._id)
    }
    selectCard(e){
      self.selectingCardIndex = e.item.card_type_index
    }
    addCardType(){
      var category_id = self.categories[self.selectingCategoryIndex]._id;
      RiotControl.off('default_card_type_got')
      RiotControl.one('default_card_type_got',function(card_type){
        card_type.category_id = category_id
        self.mountDialog("card-type-dialog",{card:card_type, type: self.type});
      })
      RiotControl.trigger('default_card_type_get')
    }
    addCard(){
      var cardType = self.card_types[self.selectingCardIndex]
      var newCard = $.extend(true,{},cardType);

      newCard.cardtype_url = cardType.image_url
      if(cardType.overlay_url) {
        newCard.cardtype_url = cardType.overlay_url
        newCard.clip_cardtype = cardType.clip
      }
      delete newCard.overlay_url
      delete newCard.clip
      delete newCard.image_url

      RiotControl.trigger("card_add", newCard);
    }
    addCardOnDbclick(e){
      self.selectCard(e)
      self.addCard()
      $("#card-add-dialog").closeModal({
        complete: function() {
          self.unmountDialog();
        }
      });
    }
  </script>
</card-add-dialog>
