<!--
- dialog for edit card
- @copyright VTM Corp 2016
-->
<card-edit-dialog>
  <style>
    .card-data-wrapper  .materialize-textarea{
      height: 70px !important;
      overflow-y: scroll;
    }
    .table-input-data th,
    .table-input-data td{
      padding: 0 5px;
    }
    .btn-action-col{
      width: 20px;
      padding:0 !important;
    }
    .btn-action-col > .btn-flat{
      padding: 0;
    }
    #card-edit-dialog .image-em > .card-image-item-wrapper{
      border: 1px dashed black;
    }
  </style>
  <div id="card-edit-dialog" class="modal">
    <div class="modal-content">
      <div class="row">
        <div class="col s12">
          <h4>{ getLangText("edit_card_header") }</h4>
        </div>
      </div>
      <div class="row">
        <div class="col s4">
          <card data={ card }></card>
          <div class="action-group">
            <span>背景</span>
            <div class="btn-group">
              <a href="#" class="btn-float tooltipped" onclick={ uploadOverlay }
                data-position="bottom" data-tooltip={ getLangText("tt_card_image_upload") }><i class="material-icons">cloud_upload</i></a>
              <a href="#" class="btn-float tooltipped" show={ card.background_url } onclick={ clearOverlay }
                data-position="bottom" data-tooltip={ getLangText("tt_card_image_clear") }><i class="material-icons red-text">clear</i></a>
              <a href="#" class="btn-float tooltipped" show={ card.background_url } onclick={ doCropImage }
                data-position="bottom" data-tooltip={ getLangText("tt_card_image_trim") }><i class="material-icons black-text">crop</i></a>
            </div>
          </div>
          <div class="">
            <span>強調</span>
            <div class="btn-group">
              <a href="#" class="btn-float tooltipped" onclick={ uploadOverlayEm }
                data-position="bottom" data-tooltip={ getLangText("tt_card_image_upload") }><i class="material-icons">cloud_upload</i></a>
              <a href="#" class="btn-float tooltipped" show={ card.em_url } onclick={ clearOverlayEm }
                data-position="bottom" data-tooltip={ getLangText("tt_card_image_clear") }><i class="material-icons red-text">clear</i></a>
              <a href="#" class="btn-float tooltipped" show={ card.em_url } onclick={ doCropImageEm }
                data-position="bottom" data-tooltip={ getLangText("tt_card_image_trim") }><i class="material-icons black-text">crop</i></a>
            </div>
          </div>
        </div>
        <div class="col s8 card-data-wrapper">
          <virtual each={ data, index in card.items }>
            <div if={!data.type||data.type=="single"} class="row">
              <div class="col s11">
                <label for={ "card_item"+index }>{ data.name }</label>
                <input placeholder={ data.hint } id={ "card_item"+index } type="text"
                  value={ getContent(data.content) } class="validate tooltipped" onkeyup={ changeCardItem }
                  data-position="bottom" data-tooltip={ getLangText("tt_card_item_content") }>
              </div>
              <div class="item font_button font_button_edit col s1">
                <a href="#" class="btn waves-effect waves-light tooltipped" onclick={ openFontDialog }
                  data-position="bottom" data-tooltip={ getLangText("tt_card_font_select")}>
                  <i class="material-icons">more_horiz</i></a>
              </div>
            </div>
            <div if={data.type=="multi"} class="row">
              <div class="col s11">
                <label for={ "card_item"+index }>{ data.name }</label>
                <textarea placeholder={ data.hint } id={ "card_item"+index }
                  class="materialize-textarea validate tooltipped" onkeyup={ changeCardItem }
                  data-position="bottom" data-tooltip={ getLangText("tt_card_item_content") }>{getContent(data.content)}</textarea>
              </div>
              <div class="item font_button font_button_edit col s1">
                <a href="#" class="btn waves-effect waves-light tooltipped" onclick={ openFontDialog }
                  data-position="bottom" data-tooltip={ getLangText("tt_card_font_select")}>
                  <i class="material-icons">more_horiz</i></a>
              </div>
            </div>
            <div if={ data.type=="table" } class="row" data-index={ index }>
              <div class="col s11">
                <label>{ data.name }</label>
                <table class="table-input-data">
                  <thead><tr>
                    <th class="btn-action-col"><a class="btn-flat"
                      onclick={addRow}><i class="material-icons red-text text-darken-2">add_circle_outline</i></a></th>
                    <th each={ title in parent.getHeaders(data.table_titles)}>{title}</td>
                  </tr></thead>
                  <tbody><tr each={ row,row_index in getTableData(data.content) } data-row={ row_index }>
                    <td class="btn-action-col"><a class="btn-flat"
                        onclick={deleteRow}><i class="material-icons green-text text-darken-2">remove_circle_outline</i></a></td>
                    <td each={ propName in parent.getHeaders(data.table_titles)}>
                      <input type="text" value={getTableCellData(row, propName)} data-col={propName} onkeyup={editCell}>
                    </td>
                  </tr></tbody>
                </table>
              </div>
              <div class="item font_button font_button_edit col s1">
                <a href="#" class="btn waves-effect waves-light tooltipped" onclick={ openFontDialog }
                  data-position="bottom" data-tooltip={ getLangText("tt_card_font_select")}>
                  <i class="material-icons">more_horiz</i></a>
              </div>
            </div>
          </virtual>
        </div>
      </div>
    </div>
    <div class="modal-footer">
      <a href="#" class="modal-action modal-close waves-effect waves-green btn tooltipped" onclick={ saveCard }
        data-position="top" data-tooltip={ getLangText("tt_card_save") }>OK</a>
    </div>
  </div>

  <script>
    var self = this;
    self.card = {}
    self.cardElm=null
    self.defaultCardHeight = 125
    $.extend(true, self.card, self.opts.card);

    addRow(e){
      var $elm = $(e.currentTarget),
          index = parseInt($elm.closest(".row").attr("data-index"))
      self.card.items[index].content.push({})
    }
    deleteRow(e){
      var $elm = $(e.currentTarget),
          index = parseInt($elm.closest(".row").attr("data-index")),
          rowIndex = parseInt($elm.closest("tr").attr("data-row"))
      self.card.items[index].content.splice(rowIndex,1)
      self.card = $.extend(true,{},self.card)
    }
    editCell(e){
      var $elm = $(e.currentTarget),
          index = parseInt($elm.closest(".row").attr("data-index"))
          rowIndex = parseInt($elm.closest("tr").attr("data-row"))
          colName = $elm.attr("data-col")
      self.card.items[index].content[rowIndex][colName]=e.target.value
      self.updateCard()
      e.preventUpdate=true
    }
    updateCard(){
      var cardElm=self.cardElm
      cardElm.one("updated",function(){
        $(cardElm.root).show()
        var maxPosYTable=0
        $(cardElm.root).find(".table-data").each(function(){
          var $elm=$(this),
              posY=$elm.position().top+$elm.outerHeight()+2
          if(maxPosYTable<posY)
            maxPosYTable=posY
        })
        var height = self.defaultCardHeight
        if(maxPosYTable > self.defaultCardHeight)
          height = maxPosYTable
        if(height !=self.card.height){
          self.card.height=height
          cardElm.update()
        }
      })
      $(cardElm.root).hide()
      cardElm.update()
    }
    getTableCellData(data, name){
      return data[name]||""
    }
    getTableData(data){
      if(Array.isArray(data))
        return data
      return []
    }
    getHeaders(titles){
      if(!titles)
        return []
      return titles.split("\n")
    }
    getContent(data){
      if(Array.isArray(data))
        return ""
      return escape(data?data:"")
    }
    self.on("mount", function(){
      self.initTooltip()
      self.initMoveResizeEm()
      $("#card-edit-dialog").openModal({
        complete: function() {
          self.unmountDialog();
        }
      });
      Materialize.updateTextFields();
    })
    self.on("unmount",function(){
      interact(".image-em .card-image-item-wrapper").draggable(false)
    })
    self.on("updated",function(){
      self.cardElm=self.tags.card
      self.updateCard()
    })
    RiotControl.on('cart_type_item_update',function(item){
      self.update()
    })
    initMoveResizeEm(){
      interact(".image-em .card-image-item-wrapper")
        .draggable({
          restrict: {
            endOnly: true,
            elementRect: { top: 0, left: 0, bottom: 1, right: 1 }
          },
          onmove: self.moveEmElm,
          onend: self.moveEndEmElm
        })
        .resizable({
          edges: { left: true, right: true, bottom: true, top: true },
          restrict: {
            restriction: "parent"
          }
        })
        .on('resizemove', self.resizeMoveEmElm)
    }
    resizeMoveEmElm(event){
      var target = event.target,
          boundary = self.card.boundaryEm || {x:0,y:0}
      if(isNaN(boundary.x)) boundary.x = 0
      if(isNaN(boundary.y)) boundary.y = 0

      // update the element's style
      boundary.w  = event.rect.width
      boundary.h = event.rect.height

      // translate when resizing from top or left edges
      boundary.x += event.deltaRect.left;
      boundary.y += event.deltaRect.top;

      self.card.boundaryEm = boundary
      self.cardElm.update()
    }
    moveEmElm(event){
      // debugger
      var target = event.target,
          boundary = self.card.boundaryEm || {x:0,y:0}
      if(isNaN(boundary.x)) boundary.x = 0
      if(isNaN(boundary.y)) boundary.y = 0

      // keep the dragged position in the data-x/data-y attributes
      boundary.x = boundary.x+event.dx
      boundary.y = boundary.y+event.dy

      self.card.boundaryEm = boundary
      self.updateCard()
    }
    changeCardItem(e){
      var index = e.item.index;
      var content = $(e.currentTarget).val();

      self.card.items[index].content = content;
      self.updateCard()
      e.preventUpdate = true
    }
    doCropImage(){
      RiotControl.off('image_croped')
      RiotControl.on('image_croped',function(info){
        self.card.clip_bg = info.clip
        self.update()
      })
      self.mountDialog("crop-image-dialog",{
        url: self.card.background_url,
        clip: self.card.clip_bg,
        defaultClip: [0,0,200,125]
      })
    }
    uploadOverlay(){
      RiotControl.off('image_uploaded')
      RiotControl.one('image_uploaded',function(filename){
        self.card.background_url = filename
        self.card.clip_bg = null
        self.update()
      })

      RiotControl.trigger('image_upload')
    }
    clearOverlay(){
      self.card.background_url = ""
      self.card.clip_bg = null
    }
    doCropImageEm(){
      RiotControl.off('image_croped')
      RiotControl.on('image_croped',function(info){
        self.card.clip_em = info.clip
        self.updateCard()
      })
      self.mountDialog("crop-image-dialog",{
        url: self.card.em_url,
        clip: self.card.clip_em,
        defaultClip: [0,0,100,100]
      })
    }
    uploadOverlayEm(){
      RiotControl.off('image_uploaded')
      RiotControl.one('image_uploaded',function(filename){
        self.card.em_url = filename
        self.card.clip_em = null
        self.card.boundaryEm = null
        // self.initMoveResizeEm()
        self.update()
      })
      RiotControl.trigger('image_upload')
    }
    clearOverlayEm(){
      self.card.em_url = ""
      self.card.clip_em = null
    }
    saveCard(e){
      RiotControl.trigger("card_update", self.card);
    }
    openFontDialog(e){
      self.mountDialog("font-setting-dialog",{item: self.card.items[e.item.index]})
    }
  </script>
</card-edit-dialog>
