<!--
- dialog for edit card type content
- @copyright VTM Corp 2016
-->
<card-type-dialog>
  <div id="card-type-dialog" class="modal">
    <div class="modal-content">
      <div class="row">
        <div class="col s12 center-align">
          <h4>{ getLangText("card_type")}</h4>
        </div>
      </div>
      <div class="row">
        <div class="col s6 input-field">
          <label class="tooltipped" data-position="top" data-tooltip={ getLangText("tt_ct_name") }>
            { getLangText("name")}</label>
          <input type="text" value={ card.name } onkeyup={ changeName }>
        </div>
        <div class="col s6 input-field">
          <select onchange={ changeCategory }>
            <option value="" disabled>{ getLangText("choose_your_option")}</option>
            <option each={ categories } value={ _id } selected={ isSelectedCategory(this) }>{ name }</option>
          </select>
          <label class="tooltipped" data-position="top" data-tooltip={ getLangText("tt_ct_cate") }>
            { getLangText("category") }</label>
        </div>
      </div>
      <div class="row">
        <div class="col s3">
          <div class="tooltipped" data-position="bottom" data-tooltip={ getLangText("tt_ct_image_view") }>
            <card-type data={ card } highlightindex={ highlightIndex }></card-type>
          </div>
          <a href="#" class="tooltipped btn-float" onclick={ uploadImage }
             data-position="bottom" data-tooltip={ getLangText("tt_ct_image_upload") }><i class="material-icons">cloud_upload</i></a>
          <a href="#" class="tooltipped btn-float" show={ card.overlay_url } onclick={ doCropImage }
             data-position="bottom" data-tooltip={ getLangText("tt_ct_image_trim") }><i class="material-icons black-text">crop</i></a>
        </div>
        <div class="col s9 card-type-item-wrapper">
          <div class="row">
            <div class="col s12">
              <label class="item mark-drag"></label>
              <label class="tooltipped item name" data-position="top" data-tooltip={ getLangText("tt_ct_item_name") }>
                { getLangText("item_name") }</label>
              <label class="tooltipped item hint" data-position="top" data-tooltip={ getLangText("tt_ct_item_hint") }>
                { getLangText("hint") }</label>
              <label class="tooltipped item pos_left" data-position="top" data-tooltip={ getLangText("tt_ct_item_x") }>
                { getLangText("posx") }</label>
              <label class="tooltipped item pos_top" data-position="top" data-tooltip={ getLangText("tt_ct_item_y") }>
                { getLangText("posy") }</label>
              <label class="tooltipped item size_width" data-position="top" data-tooltip={ getLangText("tt_ct_item_w") }>
                { getLangText("width") }</label>
              <label class="tooltipped item size_height" data-position="top" data-tooltip={ getLangText("tt_ct_item_h") }>
                { getLangText("height") }</label>
              <label class="tooltipped item font_button" data-position="top" data-tooltip={ getLangText("tt_ct_item_font") }>
                { getLangText("font") }</label>
              <label class="tooltipped item type_button" data-position="top" data-tooltip={ getLangText("tt_ct_item_card_item_type") }>
                { getLangText("card_item_type") }</label>
            </div>
          </div>
          <div class="card-data-wrapper">
            <ol class="vertical">
              <li each={ data, index in card.items } data-position={index} class="row" onkeyup={ changeItem } onclick={ selectItem }>
                <div class="card-data-item col s12">
                  <div class="item mark-drag">
                    ＝
                  </div>
                  <div class="input-field item name">
                    <input type="text" value={ data.name }>
                  </div>
                  <div class="input-field item hint">
                    <input type="text" value={ data.hint }>
                  </div>
                  <div class="input-field item pos_left">
                    <input type="number" value={ data.left }>
                  </div>
                  <div class="input-field item pos_top">
                    <input type="number" value={ data.top }>
                  </div>
                  <div class="input-field item size_width">
                    <input type="number" value={ data.width }>
                  </div>
                  <div class="input-field item size_height">
                    <input type="number" value={ data.height }>
                  </div>
                  <div class="input-field item font_button">
                    <a href="#" class="btn waves-effect waves-light" onclick={ openFontDialog }>
                      <i class="material-icons">more_horiz</i></a>
                  </div>
                  <div class="input-field item type_button">
                    <a href="#" class="btn waves-effect waves-light light-green" onclick={ openCardTypeTypeDialog }>
                      <i class="material-icons">more_horiz</i></a>
                  </div>
                  <a href="#" class="tooltipped btn-flat waves-effect waves-blue item btn-remove"
                    data-position="bottom" data-tooltip={ getLangText("tt_ct_item_delete") }
                    onclick={ deleteItem }><i class="material-icons">delete</i></a>
                </div>
              </li>
            </ol>
          </div>
        </div>
      </div>
    </div>
    <div class="modal-footer">
      <a href="#" class="tooltipped modal-action modal-close waves-effect waves-green btn" onclick={ saveCard }
        data-position="top" data-tooltip={ getLangText("tt_ct_save") }>{ getLangText("ok") }</a>
      <a href="#" class="tooltipped btn-floating btn-large waves-effect waves-green btn-add-card-item" onclick={ addItem }
        data-position="top" data-tooltip={ getLangText("tt_ct_item_add") }>
        <i class="material-icons">add</i>
      </a>
    </div>
  </div>
  <script>
    var self = this
    self.card = $.extend(true, {}, self.opts.card)
    self.highlightIndex = null
    self.categories = null
    self.type = self.opts.type
    self.defaultCardWidth = 125

    self.on("mount", function(){
      $("#card-type-dialog").openModal({
        complete: function() {
          self.unmountDialog()
        }
      })
      RiotControl.off('categories_got')
      RiotControl.one('categories_got',function(categories){
        self.categories = categories
        self.one('updated',function(){
          $('select').material_select()
        })

        self.update()
      })
      RiotControl.trigger('categories_get', self.type)
      Materialize.updateTextFields()

    })
    self.on("updated",function(){
      self.initTooltip()
      $('.card-data-wrapper > ol').sortable({
          onDrop: function ($item, container, _super, event) {
            $item.removeClass(container.group.options.draggedClass).removeAttr("style")
            $("body").removeClass(container.group.options.bodyClass)

            var new_card_items = []
            container.el.find("> li").each(function(){
              new_card_items.push(self.card.items[$(this).data("position")])
              $(this).data("position",new_card_items.length - 1)
            })
            self.card.items = new_card_items
            self.update()
          }
      })
      if(self.type!="map")
        $(".type_button").hide()
    })
    doCropImage(){
      RiotControl.off('image_croped')
      RiotControl.on('image_croped',function(info){
        self.card.clip = info.clip
        self.update()
      })
      self.mountDialog("crop-image-dialog",{
        url: self.card.overlay_url,
        clip: self.card.clip,
        defaultClip: [0,0,200,125]
      })
    }
    changeName(e){
      self.card.name = $(e.currentTarget).val()
      e.preventUpdate = true
    }
    changeCategory(e){
      self.card.category_id = $(e.currentTarget).val()
    }
    changeItem(e){
      var index = e.item.index
      var item = self.card.items[index]
      var $elm = $(e.currentTarget)

      item.name = $elm.find(".name input").val()
      item.hint = $elm.find(".hint input").val()
      item.left = $elm.find(".pos_left input").val()
      item.top = $elm.find(".pos_top input").val()
      item.height = $elm.find(".size_height input").val()
      item.width = $elm.find(".size_width input").val()
      self.updateCardType()
      e.preventUpdate = true
    }
    updateCardType(){
      var cardType = self.tags["card-type"]
      cardType.update()
    }
    selectItem(e){
      self.highlightIndex = e.item.index
    }
    deleteItem(e){
      self.card.items.splice(e.item.index,1)
    }
    isSelectedCategory(category){
      return self.card.category_id == category._id
    }
    addItem(){
      RiotControl.off('default_card_type_item_got')
      RiotControl.one('default_card_type_item_got', function(card_type_item){
        self.card.items.push(card_type_item)
        self.highlightIndex = self.card.items.length-1
        self.one("updated",function(){
          $(".card-data-item:last .name input").focus()
        })
        self.update()
      })
      RiotControl.trigger('default_card_type_item_get', self.type)
    }
    saveCard(e){
      RiotControl.trigger("card_type_update", self.type, self.card)
    }
    uploadImage(){
      RiotControl.off('image_uploaded')
      RiotControl.one('image_uploaded',function(filename){
        self.card.overlay_url = filename
        self.update()
      })
      RiotControl.trigger('image_upload')
    }
    openFontDialog(e){
      RiotControl.off('cart_type_item_update')
      RiotControl.one('cart_type_item_update',function(item){
        self.updateCardType()
      })
      self.mountDialog("font-setting-dialog",{item: self.card.items[e.item.index]})
    }
    openCardTypeTypeDialog(e){
      var item=self.card.items[e.item.index]
      RiotControl.off('cart_type_item_update')
      RiotControl.one('cart_type_item_update',function(tmpItem){
        item.type = tmpItem.type
        item.num_col = tmpItem.num_col
        item.table_titles = tmpItem.table_titles
        item.content = tmpItem.content
        self.updateCardType()
      })
      self.mountDialog("cardtype-type-setting-dialog",{item: item})
    }
  </script>
</card-type-dialog>
