<!--
- display card type content with formated text, image
- @copyright VTM Corp 2016
-->
<card-type>
  <div class="card" style={"height: "+opts.data.height+"px;"}>
    <img if={ !isUseClip } class="card-image" src={ getDataPath("img/")+getImageUrl() } alt={ name } />
    <div if={ isUseClip } class="card-image-crop" style={
        "overflow: hidden;"+
        "width: "+clip.w+"px;"+
        "height: "+clip.h+"px;"+
        calTransform()
      }>
      <img src={ getDataPath("img/")+getImageUrl() } alt={ name } style={
        "margin-left: -"+clip.x+"px;"+
        "margin-top: -"+clip.y+"px;"
      } />
    </div>
    <virtual each={ data, index in opts.data.items }>
      <raw if={ !data.type||data.type=="single"||data.type=="multi" }
        class={ card-data:true, hightlight:isHighlight(index), vertical: data.orientation=="vertical"}
        style={ getTextStyle(data)+getPostionStyle(data) } content={ getContent(data) }>
      </raw>
      <table if={ data.type=="table"} class="table-data" style={getPostionStyle(data)+getTextStyle(data)}>
        <thead><tr>
          <th each={ title in parent.getHeaders(data.table_titles)}>{title}</td>
        </tr></thead>
        <tbody><tr each={ row,row_index in data.content }>
          <td each={ propName in parent.getHeaders(data.table_titles)}>{getTableData(row, propName)}</td>
        </tr></tbody>
      </table>
    </virtual>
  </div>
  <script>
    var self = this
    self.isUseClip = true
    self.cardWidth = 200
    self.cardHeight = 125

    self.on("update",function(){
      self.isUseClip = !(self.opts.notUseClip === true) && (!!self.opts.data.clip)

      self.clip = {x:0,y:0,w:1,h:1}
      if(self.isUseClip) self.clip = self.opts.data.clip
    })
    getTableData(data, name){
      return data[name]||"　"
    }
    getHeaders(titles){
      return titles.split("\n")
    }
    isHighlight(index){
      return self.opts.highlightindex !== null && self.opts.highlightindex == index
    }
    getImageUrl(){
      return opts.data.overlay_url?opts.data.overlay_url:opts.data.image_url
    }
    calZoomLevel(parentWidth, childWidth){
      return parentWidth/childWidth
    }
    calTransform(){
      var scale=self.calZoomLevel(self.opts.data.width||self.cardWidth,self.clip.w)
      var res = "transform: "+
        " scaleX("+scale+")"+
        " scaleY("+scale+");"+
        " transform-origin: 0 0;"
      return res
    }
    getPostionStyle(data){
      var res = "top:"+data.top+"px;"+
        "left:"+data.left+"px;"+
        "width:"+data.width+"px;"+
        "height:"+data.height+"px;"
      return res
    }
    getTextStyle(data){
        var res ="font-family:"+data.font_name+";"+
        "color:"+data.color+";"+
        "text-orientation:"+data.text_mode+";"+
        "font-size: "+(data.font_size*2)+"px;"+
        "text-align: "+(data.position)+";"
      if(data.style == "bold") res = res+"font-weight: bold;"
      if(data.style == "italic") res = res+"font-style: italic;"
      if(data.autofit == "false") res = res+"white-space: nowrap;"
      return res
    }
    getContent(elm){
      return escape(elm.name?elm.name:" ").replace(/(?:\r\n|\r|\n)/g, '<br />')
    }
  </script>
</card-type>
