<!--
- display card content with formated text, image(image background, card type, emphasize)
- @copyright VTM Corp 2016
-->
<card>
  <div class="card" style={"height: "+opts.data.height+"px;"}>
    <card-image-item class="image-background" if={ opts.data.background_url } data={ getBackgroundObject() }></card-image-item>
    <card-image-item class="image-cardtype" if={ opts.data.cardtype_url } data={ getCardtypeObject() }></card-image-item>
    <card-image-item class="image-em" if={ opts.data.em_url } data={ getEmObject() }></card-image-item>
    <virtual each={ data, index in opts.data.items }>
      <raw if={ !data.type||data.type=="single"||data.type=="multi" }
        class={ card-data:true, vertical: data.orientation=="vertical"}
        style={ getStyle(data) } content={ getContent(data.content) }>
      </raw>
      <table if={ data.type=="table"} class="table-data" style={getStyle(data)}>
        <thead><tr>
          <th each={ title in parent.getHeaders(data.table_titles)}>{title}</td>
        </tr></thead>
        <tbody><tr each={ row,row_index in getTableData(data.content) }>
          <td each={ propName in parent.getHeaders(data.table_titles)}>{getTableCellData(row, propName)}</td>
        </tr></tbody>
      </table>
    </virtual>
  </div>
  <script>
    var self = this
    self.bgBoundary = {x:0, y:0, w:200}
    self.defEmBoundary = {x:0, y:0, w:152, h:95}

    getTableCellData(data, name){
      return data[name]||"　"
    }
    getTableData(data){
      if(Array.isArray(data))
        return data
      return []
    }
    getHeaders(titles){
      if(!titles)
        return []
      return titles.split("\n")
    }
    getEmObject(){
      var boundEm = opts.data.boundaryEm
      if(!boundEm)
        boundEm = self.defEmBoundary
      boundEm.w = boundEm.w || self.defEmBoundary.w
      boundEm.h = boundEm.h || self.defEmBoundary.h

      return {
        url: self.getImageUrl(opts.data.em_url),
        clip: opts.data.clip_em,
        boundary: boundEm
      }
    }
    getBackgroundObject(){
      return {
        url: self.getImageUrl(opts.data.background_url),
        clip: opts.data.clip_bg,
        boundary: self.bgBoundary
      }
    }
    getCardtypeObject(){
      return {
        url: self.getImageUrl(opts.data.cardtype_url),
        clip: opts.data.clip_cardtype,
        boundary: self.bgBoundary
      }
    }
    getImageUrl(url){
      var baseUrl = self.getDataPath("img/")
      if(self.opts.base_url)
        baseUrl = self.opts.base_url
      return baseUrl+url
    }
    getStyle(data){
      var res = "top:"+data.top+"px;"+
        "left:"+data.left+"px;"+
        "width:"+data.width+"px;"+
        "height:"+data.height+"px;"+
        "font-family:"+data.font_name+";"+
        "color:"+data.color+";"+
        "text-orientation:"+data.text_mode+";"+
        "font-size: "+(data.font_size*2)+"px;"+
        "text-align: "+(data.position)+";"
      if(data.style == "bold") res = res+"font-weight: bold;"
      if(data.style == "italic") res = res+"font-style: italic;"
      if(data.autofit == "false") res = res+"white-space: nowrap;"
      return res
    }
    getContent(data){
      if(Array.isArray(data))
        return " "
      return escape(data?data:" ").replace(/(?:\r\n|\r|\n)/g, '<br/>')
    }
  </script>
</card>
