<!--
- dialog for setting cardtype
- @copyright VTM Corp 2016
-->
<cardtype-type-setting-dialog>
  <style>
    .table-title{
      height: 140px !important;
      overflow-y: scroll !important;
    }
  </style>
  <div id="cardtype-type-setting-dialog" class="modal">
    <div class="modal-content">
      <div class="row">
        <div class="col s12 center-align">
          <h4>{ getLangText("cardtype_type_setting") }</h4>
        </div>
      </div>
      <div class="row">
        <div class="col s3">
          { getLangText("cardtype_type_select") }
          <select onchange={changeType}>
            <option each={ settings.types } value={ code }
              selected={ code == contentItem.type }>{ name }</option>
          </select>
        </div>
        <div class="col s6 offset-s3">
          <div class="row">
            { getLangText("cardtype_type_table_header") }
          </div>
          <div class="col s6 offset-s1">
            { getLangText("cardtype_type_table_num_col") }
            <select onchange={changeNumCol} disabled={contentItem.type!="table"}>
              <option each={ settings.num_cols } value={ code }
                selected={ code == contentItem.num_col }>{ name }</option>
            </select>
          </div>
          <div class="col s11 offset-s1">
            <div>{ getLangText("cardtype_type_table_titles") }</div>
            <textarea onchange={changeTitles} class="materialize-textarea table-title"
              disabled={contentItem.type!="table"}>{ contentItem.table_titles }</textarea>
          </div>
        </div>
      </div>
    </div>
    <div class="modal-footer">
      <a href="#" class="waves-effect waves-green btn" onclick={ save }>
        { getLangText("ok") }</a>
    </div>
  </div>
  <script>
    var self = this
    self.settings = null
    self.contentItem = $.extend(true,{},self.opts.item)
    self.on("mount",function(){
      RiotControl.off("cardtype_type_settings_got")
      RiotControl.one("cardtype_type_settings_got",function(settings){
        $("#cardtype-type-setting-dialog").openModal({
          complete: function() {
            self.unmountDialog()
          }
        })
        self.settings = settings
        var tmpItem = self.contentItem
        tmpItem.type = tmpItem.type || settings.default.type
        tmpItem.num_col = tmpItem.num_col || settings.default.num_col
        tmpItem.table_titles = tmpItem.table_titles || settings.default.table_titles

        self.update()
      })
      RiotControl.trigger("cardtype_type_settings_get")
    })
    self.on("updated",function(){
      $('select').material_select()
    })
    changeType(e){
      self.contentItem.type = e.currentTarget.value
    }
    changeNumCol(e){
      self.contentItem.num_col = e.currentTarget.value
    }
    changeTitles(e){
      self.contentItem.table_titles= e.currentTarget.value
    }
    save(){
      var tmpItem = self.contentItem
      var funcSave=function(){
        $("#cardtype-type-setting-dialog").closeModal({
          complete: function() {
            self.unmountDialog()
          }
        })
        RiotControl.trigger("cart_type_item_update", tmpItem)
      }
      if(tmpItem.type=="table"){
        if(!tmpItem.table_titles||tmpItem.table_titles.length<=0)
          alert(self.getLangText("cardtype_type_need_titles"))
        else{
          var headers = tmpItem.table_titles.split("\n")
          if(headers.length!=parseInt(tmpItem.num_col))
            alert(self.getLangText("cardtype_type_num_col_not_match"))
          else{
            for(var headerIndex=0; headerIndex<headers.length; headerIndex++)
              if(headers[headerIndex].trim().length<=0){
                alert(self.getLangText("cardtype_type_num_col_not_match"))
                return
              }
            if(!Array.isArray(tmpItem.content))
              tmpItem.content=[{}]
            funcSave()
          }
        }
      }
      else{
        if(Array.isArray(tmpItem.content))
          tmpItem.content=""
        funcSave()
      }
    }
  </script>
</cardtype-type-setting-dialog>
