<!--
- dialog for select and create categories of card type
- @copyright VTM Corp 2016
-->
<category-dialog>
  <div id="category-dialog" class="modal">
    <div class="modal-content">
      <h4 class="center-align">{ getLangText("categories") }</h4>
      <div class="category-header">
        <label class="tooltipped" data-position="bottom" data-tooltip={ getLangText("tt_category_input") }>{ getLangText("category_name") }</label>
      </div>
      <div class="category-list">
        <ol class="vertical">
          <li each={ category,category_index in categories } data-position={ category_index }>
            <div class={ category-item:true }>
              <span class="tooltipped" data-position="bottom" data-tooltip={ getLangText("tt_category_sort") }>＝</span><input value={ category.name } onchange={ changeCategory }>
              <a href="#" class="btn-flat waves-effect waves-green tooltipped" onclick={ deleteCategory }
                 data-position="bottom" data-tooltip={ getLangText("tt_category_delete") }>
                <i class="material-icons red-text">delete</i>
              </a>
            </div>
          </li>
        </ol>
      </div>
    </div>
    <div class="modal-footer">
      <a href="#" class="tooltipped modal-action modal-close waves-effect waves-green btn" onclick={ saveCategories }
        data-position="top" data-tooltip={ getLangText("tt_category_save") }>{ getLangText("ok") }</a>
      <a href="#" class="tooltipped btn-floating btn-large waves-effect waves-green btn-add-category" onclick={ addCategory }
        data-position="top" data-tooltip={ getLangText("tt_category_add") }>
        <i class="material-icons">add</i>
      </a>
    </div>
  </div>
  <script>
    require('jquery-sortable')
    var self = this
    self.categories = []
    self.deleteIds = []
    self.type = self.opts.type

    self.on("mount", function(){
      $("#category-dialog").openModal({
        complete: function() {
          self.unmountDialog()
        }
      });

      RiotControl.off('categories_got')
      RiotControl.one('categories_got',function(categries){
        self.categories = categries
        self.update()
      })
      RiotControl.trigger('categories_get', self.type)
    })
    self.on("updated",function(){
      self.initTooltip()
      $('.category-list > ol').sortable({
          onDrop: function ($item, container, _super, event) {
            $item.removeClass(container.group.options.draggedClass).removeAttr("style")
            $("body").removeClass(container.group.options.bodyClass)

            var new_categories = []
            container.el.find("> li").each(function(){
              new_categories.push(self.categories[$(this).data("position")])
              $(this).data("position",new_categories.length - 1)
            })
            self.categories = new_categories
          }
      })
    })

    addCategory(e){
      RiotControl.off("default_category_got")
      RiotControl.one("default_category_got",function(category){
        self.categories.push(category)
        self.update()
      })
      RiotControl.trigger("default_category_get", self.type)
    }
    deleteCategory(e){
      self.deleteIds.push(e.item.category._id)
      self.categories.splice(e.item.category_index,1)
    }
    changeCategory(e){
      var newName = $(e.currentTarget).val()
      self.categories[e.item.category_index].name = newName
    }
    saveCategories(){
      RiotControl.trigger("categories_update", self.type, self.categories, self.deleteIds)
    }
  </script>
</category-dialog>
