<!--
- dialog for edit connection
- @copyright VTM Corp 2016
-->
<connection-edit-dialog>
  <style>
    #connection-edit-dialog{
      min-width: 700px;
    }
    #connection-edit-dialog > .modal-content{
      min-height: 450px;
    }
    .text-content-data {
      float: left;
      width: 88px;
    }
    .text-content-data input{
      height: 2.3em;
    }
    .text-content-font {
      float: left;
      width: 49px;
      margin-left: 3px;
    }
    .text-content-font .btn{
      padding: 0 10px;
    }
    .select-content-data {
      width: 46%;
      float: left;
      margin-left: 5px;
    }
    .connection-setting-wrapper{
      position: relative;
      margin-top: 40px;
      margin-left: -5px;
      height: 35px;
    }
    .connection-setting-wrapper .arrow{
      width: 90% !important;
      margin-left: 10px;
    }
    .btn-delete-connection{
      padding: 0;
      margin-top: -27px !important;
      height: 70px;
      float: left !important;
    }
    .btn-delete-connection > i{
      font-size: 5em;
      line-height: 82px;
    }
    .btn-insert-card{
      margin-right: 15px !important;
    }
  </style>
  <div id="connection-edit-dialog" class="modal">
    <div class="modal-content">
      <div class="row">
        <div class="col s12">
          <h4>{ getLangText("edit_connection_header") }</h4>
        </div>
      </div>
      <div class="row">
        <div class="text-content col s3 offset-s3">
          <div class="text-content-data">
            <label>{ getLangText("tail_label") }</label>
            <input type="text" value={ shape.tail.content } onkeyup={ changeTailText }>
          </div>
          <div class="text-content-font">
            <label>{ getLangText("font") }</label><br>
            <a href="#" class="btn waves-effect waves-light" onclick={ changeTailTextStyle }>
              <i class="material-icons">more_horiz</i></a>
          </div>
        </div>
        <div class="text-content col s3">
          <div class="text-content-data">
            <label>{ getLangText("middle_label") }</label>
            <input type="text" value={ shape.middle.content } onkeyup={ changeMiddleText }>
          </div>
          <div class="text-content-font">
            <label>{ getLangText("font") }</label><br>
            <a href="#" class="btn waves-effect waves-light" onclick={ changeMiddleTextStyle }>
              <i class="material-icons">more_horiz</i></a>
          </div>
        </div>
        <div class="text-content col s3">
          <div class="text-content-data">
            <label>{ getLangText("head_label") }</label>
            <input type="text" value={ shape.head.content } onkeyup={ changeHeadText }>
          </div>
          <div class="text-content-font">
            <label>{ getLangText("font") }</label><br>
            <a href="#" class="btn waves-effect waves-light" onclick={ changeHeadTextStyle }>
              <i class="material-icons">more_horiz</i></a>
          </div>
        </div>
      </div>
      <div class="row">
        <div class="select-content col s3">
          <div class="select-content-data">
            <label>{ getLangText("weight_label") }</label>
            <select onchange={ changeLineWidth }>
              <option each={ settings.widths } value={ code }
                selected={ code == shape.arrow.line.size }>{ name }</option>
            </select>
          </div>
          <div class="select-content-data">
            <label>{ getLangText("color_label") }</label><br>
            <select  onchange={ changeColor }>
              <option each={ settings.colors } value={ code }
                selected={ code == shape.arrow.all.color }>{ name }</option>
            </select>
          </div>
        </div>
        <div class="connection-setting-wrapper col s9">
          <connection shape={shape} from={from} to={to}></connection>
        </div>
      </div>
      <div class="row">
        <div class="select-content col s3 offset-s3">
          <div class="select-content-data">
            <label>{ getLangText("tail_type_label") }</label>
            <select onchange={changeTailType}>
              <option each={ settings.tail_types } value={ code }
                selected={ code == shape.arrow.tail.type }>{ name }</option>
            </select>
          </div>
          <div class="select-content-data">
            <label>{ getLangText("tail_size_label") }</label><br>
            <select onchange={changeTailSize}>
              <option each={ settings.widths } value={ code }
                selected={ code == shape.arrow.tail.size }>{ name }</option>
            </select>
          </div>
        </div>
        <div class="select-content col s3 offset-s3">
          <div class="select-content-data">
            <label>{ getLangText("head_type_label") }</label>
            <select onchange={changeHeadType}>
              <option each={ settings.head_types } value={ code }
                selected={ code == shape.arrow.head.type }>{ name }</option>
            </select>
          </div>
          <div class="select-content-data">
            <label>{ getLangText("head_size_label") }</label><br>
            <select onchange={changeHeadSize}>
              <option each={ settings.widths } value={ code }
                selected={ code == shape.arrow.head.size }>{ name }</option>
            </select>
          </div>
        </div>
      </div>
    </div>
    <div class="modal-footer">
      <a href="#" class="modal-action modal-close waves-effect waves-green btn" onclick={ save }>OK</a>
      <a href="#" class="modal-action waves-effect waves-green btn btn-insert-card" onclick={ insert }>{getLangText("card_insert_label") }</a>

      <a href="#" class="waves-effect waves-green btn-flat btn-delete-connection" onclick={ delete }><i class="material-icons">delete_forever</i></a>
    </div>
  </div>

  <script>
    var uuid = require('node-uuid')
    var self = this
    self.settings = null
    self.shape = $.extend(true,{},self.opts.shape)
    self.from = {x:0, y:0, width:10, height:10}
    self.to = {x:300, y:0, width:10, height:10}
    self.on("mount",function(){
      RiotControl.one("arrow_settings_got",function(settings){
        $("#connection-edit-dialog").openModal({
          complete: function() {
            self.unmountDialog()
          }
        })
        self.settings = settings
        self.one("updated",function(){
          self.initTooltip()
          $('select').material_select();
        })
        self.update()
      })
      RiotControl.trigger("arrow_settings_get")
    })
    changeTextStyle(style){
      RiotControl.one('cart_type_item_update',function(item){
        self.update()
      })
      self.mountDialog("font-setting-dialog",{item: style, type: "link_item"})
    }
    changeTailText(e){
      self.shape.tail.content=e.target.value
    }
    changeTailTextStyle(e){
      self.changeTextStyle(self.shape.tail.style)
    }
    changeMiddleText(e){
      self.shape.middle.content=e.target.value
    }
    changeMiddleTextStyle(e){
      self.changeTextStyle(self.shape.middle.style)
    }
    changeHeadText(e){
      self.shape.head.content=e.target.value
    }
    changeHeadTextStyle(e){
      self.changeTextStyle(self.shape.head.style)
      self.updateArrow()
    }
    changeLineWidth(e){
      self.shape.arrow.line.size=e.currentTarget.value
      self.updateArrow()
    }
    changeColor(e){
      self.shape.arrow.all.color=e.currentTarget.value
      self.updateArrow()
    }
    changeTailType(e){
      self.shape.arrow.tail.type=e.currentTarget.value
      self.updateArrow()
    }
    changeTailSize(e){
      self.shape.arrow.tail.size=e.currentTarget.value
      self.updateArrow()
    }
    changeHeadType(e){
      self.shape.arrow.head.type=e.currentTarget.value
      self.updateArrow()
    }
    changeHeadSize(e){
      self.shape.arrow.head.size=e.currentTarget.value
      self.updateArrow()
    }
    updateArrow(){
      $(".connection-setting-wrapper").hide()
      self.one("updated",function(){
        $(".connection-setting-wrapper").show()
      })
    }
    closeDialog(){
      $("#connection-edit-dialog").closeModal({
        complete: function() {
          self.unmountDialog()
        }
      })
    }
    save(){
      RiotControl.trigger("connection_update",self.shape)
    }
    delete(){
      self.mountDialog("confirm-dialog",{
        message: self.getLangText("msg_sure_to_delete"),
        doOK: function(){
          RiotControl.trigger("connection_remove")
          self.closeDialog()
        }
      })
    }
    insert(){
      RiotControl.off("card_add")
      RiotControl.one("card_add", function(card){
        card.id = uuid.v1()
        RiotControl.trigger('card_insert',card)
        self.closeDialog()
      })
      self.mountDialog("card-add-dialog", {type: "map"})
    }
  </script>
</connection-edit-dialog>
