<!--
- show connection
- @copyright VTM Corp 2016
-->
<connection>
  <div class={arrow:true, arrow-text-rotate:arrowTransform&&arrowTransform.angleA<-90} style={getArrowTranform()}>
		<div class={"arrow-shape"+getShapeClasses(shape.arrow.all)}>
			<div class={"arrow-line"+getShapeClasses(shape.arrow.line)}></div>
			<div if={ shape.arrow.head } class={"arrow-head"+getShapeClasses(shape.arrow.head)}></div>
			<div if={ shape.arrow.tail } class={"arrow-tail"+getShapeClasses(shape.arrow.tail)}></div>
		</div>
    <div class="arrow-text text-tail">
      <card-content class={card-data: true, vertical: shape.tail.style.orientation=="vertical" }
        style={ getTextStyle(shape.tail.style) }>
        { getTextContent(shape.tail.content) }
      </card-content>
    </div>
    <div class="arrow-text text-middle">
      <card-content class={card-data: true, vertical: shape.middle.style.orientation=="vertical" }
        style={ getTextStyle(shape.middle.style) }>
        { getTextContent(shape.middle.content) }
      </card-content>
    </div>
    <div class="arrow-text text-head">
      <card-content class={card-data: true, vertical: shape.head.style.orientation=="vertical" }
        style={ getTextStyle(shape.head.style) }>
        { getTextContent(shape.head.content) }
      </card-content>
    </div>
	</div>
  <script>
    var self=this
    self.shape=self.opts.shape
    self.from=self.opts.from
    self.to=self.opts.to
    self.arrowTransform=null
    self.marginSize=3
    self.on("update",function(){
      self.calculate()
    })
    /*--------connect functions---------------*/
    calculate(){
      var shapeFrom={},shapeTo={},shapeCalculated={}
      if(!self.from || !self.to || !self.shape) return

      shapeFrom.coords = self.getCoords(self.from)
      shapeTo.coords = self.getCoords(self.to)

      //if 2 shape interset hide arrow
      if((shapeTo.coords.cc[0]>=shapeFrom.coords.ll&&shapeTo.coords.cc[0]<=shapeFrom.coords.rl)&&
          (shapeTo.coords.cc[1]>=shapeFrom.coords.ul&&shapeTo.coords.cc[1]<=shapeFrom.coords.dl)){
            self.arrowTransform=null
            return
          }

      if((shapeFrom.coords.cc[0] - shapeTo.coords.cc[0])!=0)
        var tanA=(shapeFrom.coords.cc[1] - shapeTo.coords.cc[1]) / (shapeFrom.coords.cc[0] - shapeTo.coords.cc[0])
      else
        var tanA=shapeFrom.coords.cc[1] - shapeTo.coords.cc[1]
      var beta=shapeFrom.coords.cc[1]-tanA*shapeFrom.coords.cc[0]
      var absTanA=Math.abs(tanA)

      if(shapeFrom.coords.cc[0]<shapeTo.coords.cc[0]){
        if(shapeFrom.coords.cc[1]<shapeTo.coords.cc[1]){
          if(absTanA<shapeFrom.coords.absTanA)
            shapeCalculated.sc=[shapeFrom.coords.rl, shapeFrom.coords.rl*tanA+beta]
          else
            shapeCalculated.sc=[(shapeFrom.coords.dl-beta)/tanA, shapeFrom.coords.dl]
          if(absTanA<shapeTo.coords.absTanA)
            shapeCalculated.ec=[shapeTo.coords.ll, shapeTo.coords.ll*tanA+beta]
          else
            shapeCalculated.ec=[(shapeTo.coords.ul-beta)/tanA, shapeTo.coords.ul]
        }
        else{
          if(absTanA<shapeFrom.coords.absTanA)
            shapeCalculated.sc=[shapeFrom.coords.rl, shapeFrom.coords.rl*tanA+beta]
          else
            shapeCalculated.sc=[(shapeFrom.coords.ul-beta)/tanA, shapeFrom.coords.ul]
          if(absTanA<shapeTo.coords.absTanA)
            shapeCalculated.ec=[shapeTo.coords.ll, shapeTo.coords.ll*tanA+beta]
          else
            shapeCalculated.ec=[(shapeTo.coords.dl-beta)/tanA, shapeTo.coords.dl]
        }
      }
      else{
        if(shapeFrom.coords.cc[1]<shapeTo.coords.cc[1]){
          if(absTanA<shapeFrom.coords.absTanA)
            shapeCalculated.sc=[shapeFrom.coords.ll, shapeFrom.coords.ll*tanA+beta]
          else
            shapeCalculated.sc=[(shapeFrom.coords.dl-beta)/tanA, shapeFrom.coords.dl]
          if(absTanA<shapeTo.coords.absTanA)
            shapeCalculated.ec=[shapeTo.coords.rl, shapeTo.coords.rl*tanA+beta]
          else
            shapeCalculated.ec=[(shapeTo.coords.ul-beta)/tanA, shapeTo.coords.ul]
        }
        else{
          if(absTanA<shapeFrom.coords.absTanA)
            shapeCalculated.sc=[shapeFrom.coords.ll, shapeFrom.coords.ll*tanA+beta]
          else
            shapeCalculated.sc=[(shapeFrom.coords.ul-beta)/tanA, shapeFrom.coords.ul]
          if(absTanA<shapeTo.coords.absTanA)
            shapeCalculated.ec=[shapeTo.coords.rl, shapeTo.coords.rl*tanA+beta]
          else
            shapeCalculated.ec=[(shapeTo.coords.dl-beta)/tanA, shapeTo.coords.dl]
        }
      }

      shapeCalculated.angleA = Math.atan(tanA) * 180 / Math.PI
      if (shapeTo.coords.cc[0] <= shapeFrom.coords.cc[0]) {
          shapeCalculated.angleA -= 180
      }

      shapeCalculated.width = Math.sqrt(Math.pow(shapeCalculated.ec[0] - shapeCalculated.sc[0], 2) + Math.pow(shapeCalculated.ec[1] - shapeCalculated.sc[1], 2))
      self.arrowTransform=shapeCalculated
    };
    getCoords(elem) {
      var width = elem.width||200,
          height = elem.height||125,
          px = elem.x||0,
          cen = px + (width / 2),
          py = elem.y||0,
          mid = py + (height / 2),
          ret = {
            cc: [cen, mid],
            rl: px+width+self.marginSize,
            ll: px-self.marginSize,
            ul: py-self.marginSize,
            dl: py+height+self.marginSize,
            absTanA: height/width
          }
      return ret
    };
    getArrowTranform(){
      var shape=self.arrowTransform
      if(!shape) return 'display: none;'

      var res='top: '+shape.sc[1]+'px;'+
          'left: '+shape.sc[0]+'px;'+
          'width: '+shape.width+'px;'+
          'transform: translate(0,-50%) rotate('+shape.angleA+'deg);'+
          'transform-origin: 0% 50%;'
      return res
    }
    /*--------shape format functions----------*/
    getTextContent(text){
      return text || ""
    }
    getTextStyle(data){
      var res ="font-family:"+data.font_name+";"+
        "color:"+data.color+";"+
        "text-orientation:"+data.text_mode+";"+
        "font-size: "+(data.font_size*2)+"px;"
      if(data.style == "bold") res = res+"font-weight: bold;"
      if(data.style == "italic") res = res+"font-style: italic;"
      if(data.autofit == "false") res = res+"white-space: nowrap;"
      return res
    }
    getShapeClasses(data){
      var classes=""
      $.each(data,function(key, value){
        switch (key) {
          case "color":
            classes+=" arrow-color-"+value
            break;
          case "type":
            classes+=" arrow-endpoint-"+value
            break;
          case "size":
            classes+=" arrow-size-"+value
          default:
        }
      })
      return classes
    }
  </script>
</connection>
