<!--
- crop image dialog
- @copyright VTM Corp 2016
-->
<crop-image-dialog>
  <style media="screen">
    #crop-image-dialog{
      width: 630px;
    }
    .image-wrapper{
      width: 500px;
      float: left;
    }
    .btn-save{
      position: absolute;
      bottom: 10px;
      left: 530px;
    }
  </style>
  <div id="crop-image-dialog" class="modal">
    <div class="modal-content">
      <h4 class="left-align">{ getLangText("crop_dialog_title")}</h4>
      <div class="image-wrapper tooltipped" data-position="top" data-tooltip={ getLangText("tt_card_trim_image") }>
        <img class="need-crop-img" src={ getDataPath("img/")+getImageUrl() } alt="" />
      </div>
      <a href="#" class="btn blue btn-save modal-close tooltipped" onclick={ saveCropImage }
         data-position="top" data-tooltip={ getLangText("tt_card_trim_image_save") }>{ getLangText("save") }</a>
    </div>
  </div>
  <script>
    var self = this
    self.selection = null
    self.on("mount", function(){
      $("#crop-image-dialog").openModal({
        complete: function() {
          self.unmountDialog();
        }
      });
    })
    self.on("updated",function(){
      self.initTooltip()
      var preSelectBox = self.opts.clip || self.opts.defaultClip || [0,0,200,125]
      var clip = self.opts.clip

      if(clip)
        preSelectBox = [clip.x,clip.y,clip.w,clip.h]
      $(".need-crop-img")
        .Jcrop({
          boxWidth:500,
          setSelect:preSelectBox
        })
      $(".image-wrapper")
        .on('cropcreate cropmove cropend', function(e,s,c){
          self.selection = c
        })
    })
    getImageUrl(){
      return opts.url
    }
    saveCropImage(){
      if(self.selection){
        RiotControl.trigger("image_croped",{
          url: opts.url,
          clip: $.extend(true, {}, self.selection)
        })
      }
    }
  </script>
</crop-image-dialog>
