<!--
- dialog for export card type(category)
- @copyright VTM Corp 2016
-->
<export-cardtype-dialog>
  <style>
    .export-card-type-type > p{
      float: left;
      margin: 0;
      margin-right: 10px;
    }
    .list-category-data{
      height: 385px;
    }
  </style>
  <div id="export-cardtype-dialog" class="modal export-dialog">
    <div class="modal-content">
      <h4 class="center-align">{ getLangText("export_cardtype_dialog")}</h4>
      <div class="row">
        <div class="col s5">
          <div class="export-card-type-type">
            <p>
              <input name="group1" type="radio" value="story" id="card-type-story"
                checked={ type=="story"} onclick={ showStoryCategory }/>
              <label for="card-type-story">{ getLangText("story")}</label>
            </p>
            <p>
              <input name="group1" type="radio" value="memo" id="card-type-memo"
                checked={ type=="map"} onclick={ showMapCategory }/>
              <label for="card-type-memo">{ getLangText("memo")}</label>
            </p>
          </div>
          <div class="clearfix"></div>
          <ul class="collection list-category z-depth-1 white list-category-data tooltipped"
            data-position="top" data-tooltip={ getLangText("tt_export_card_type_select") }>
            <li each={ category,category_index in listCategory } class={ collection-item:true, active:category_index==parent.selectingCategoryIndex }
              onclick={ clickCategory }>{ category.name }</li>
          </ul>
        </div>
        <div class="col s2"><i class="material-icons book-to-name">arrow_forward</i></div>
        <div class="col s5">
          <div class="row book-file-name">
            <label>{ getLangText("export_file_name")}</label>
            <input type="text" class="file-name tooltipped" value={ fileExportName } onchange={ changeFileName }
              data-position="bottom" data-tooltip={ getLangText("tt_export_file") }>
          </div>
          <div class="row btn-run">
            <a href="#" class="btn tooltipped" show={ listCategory.length>0 && fileExportName } onclick={ clickRun }
              data-position="top" data-tooltip={ getLangText("tt_export_out") }>{ getLangText("run")}</a>
          </div>
        </div>
      </div>
    </div>
  </div>
  <script>
    var self = this
    var remote = require('electron').remote
    self.listCategory = []
    self.fileExportName = ""

    self.on("mount", function(){
      $("#export-cardtype-dialog").openModal({
        complete: function() {
          self.unmountDialog();
        }
      });

      self.changeCategoryType("story")
    })

    self.on("updated",function(){
      self.initTooltip()
    })
    showStoryCategory(e){
      self.changeCategoryType("story")
    }
    showMapCategory(e){
      self.changeCategoryType("map")
    }
    changeCategoryType(type){
      self.type=type
      self.selectingCategoryIndex = 0
      RiotControl.one("categories_got", self.categoriesGot)
      RiotControl.trigger("categories_get", self.type)
    }
    categoriesGot(categories){
      self.listCategory = categories
      if(categories.length > 0)
        self.selectCategory(self.selectingCategoryIndex)
      self.update()
    }
    clickRun(){
      var dialog = remote.dialog;
      dialog.showSaveDialog({
        defaultPath: self.fileExportName,
        properties: ['openDirectory']
      },function(filePath){
        if(filePath)
          self.prepareData(self.listCategory[self.selectingCategoryIndex],filePath)
      })
    }
    clickCategory(e){
      self.selectCategory(e.item.category_index)
    }
    selectCategory(categoryIndex){
      if(categoryIndex < self.listCategory.length){
        var category = self.listCategory[categoryIndex]
        self.selectingCategoryIndex = categoryIndex
        self.fileExportName = self.genExportFileName(category.name)
      }
    }
    genExportFileName(name){
      var curDateStr = Date.today().toString('yyyyMMdd')
      return name+"_"+curDateStr+".dmc"
    }
    prepareData(category, filePath){
      RiotControl.one("category_exported",function(err){
        if(!err)
          $("#export-cardtype-dialog").closeModal({
            complete: function() {
              self.unmountDialog();
            }
          });
        else
          alert(err)
        RiotControl.trigger("progress_finish")
      })
      RiotControl.trigger("category_export",{
        category_id: category._id,
        file_path: filePath,
        type: self.type
      })
      RiotControl.trigger("progress_start")
    }
    changeFileName(e){
      self.fileExportName = $(e.currentTarget).val()
      return true
    }
  </script>
</export-cardtype-dialog>
