<!--
- dialog for select import file
- @copyright VTM Corp 2016
-->
<export-import-dialog>
  <div id="export-import-dialog" class="modal">
    <div class="modal-content">
      <h4 class="center-align">{ getLangText("export_import_dialog")}</h4>
      <div class="row">
        <div class="tooltipped col s4" data-position="bottom" data-tooltip={ getLangText("tt_im_ex_book") }>
          { getLangText("book")}</div>
        <div class="col s4"><a href="#" onclick={ openExportBookDialog }
          class="waves-effect waves-green btn-flat">{ getLangText("export")}</a></div>
        <div class="col s4"><a href="#" onclick={ openImportBookDialog }
          class="waves-effect waves-green btn-flat">{ getLangText("import")}</a></div>
      </div>
      <div class="row">
        <div class="tooltipped col s4" data-position="bottom" data-tooltip={ getLangText("tt_im_ex_cate") }>
          { getLangText("card_type")}</div>
        <div class="col s4"><a href="#" onclick={ openExportCardTypeDialog }
          class="waves-effect waves-green btn-flat">{ getLangText("export")}</a></div>
        <div class="col s4"><a href="#" onclick={ openImportCardTypeDialog }
          class="waves-effect waves-green btn-flat">{ getLangText("import")}</a></div>
      </div>
      <div class="row">
        <div class="tooltipped col s4" data-position="bottom" data-tooltip={ getLangText("tt_im_ex_story") }>
          { getLangText("story")}</div>
        <div class="col s4"><a href="#" onclick={ openExportStoryDialog }
          class="waves-effect waves-green btn-flat">{ getLangText("export")}</a></div>
        <div class="col s4"><a href="#" onclick={ openImportStoryDialog }
          class="waves-effect waves-green btn-flat">{ getLangText("import")}</a></div>
      </div>
      <div class="row">
        <div class="tooltipped col s4" data-position="bottom" data-tooltip={ getLangText("tt_im_ex_map") }>
          { getLangText("map")}</div>
        <div class="col s4"><a href="#" onclick={ openExportMapDialog }
          class="waves-effect waves-green btn-flat">{ getLangText("export")}</a></div>
        <div class="col s4"><a href="#" onclick={ openImportMapDialog }
          class="waves-effect waves-green btn-flat">{ getLangText("import")}</a></div>
      </div>
      <div class="row">
        <div class="tooltipped col s4" data-position="bottom" data-tooltip={ getLangText("tt_im_ex_memo") }>
          { getLangText("memo")}</div>
        <div class="col s4"><a href="#" onclick={ openExportMemoDialog }
          class="waves-effect waves-green btn-flat">{ getLangText("export")}</a></div>
        <div class="col s4"><a href="#" onclick={ openImportMemoDialog }
          class="waves-effect waves-green btn-flat">{ getLangText("import")}</a></div>
      </div>
      <div class="row">
        <div class="tooltipped col s4" data-position="bottom" data-tooltip={ getLangText("tt_im_ex_all_data") }>
          { getLangText("all_data")}</div>
        <div class="col s4"><a href="#" onclick={ openExportAllDataDialog }
          class="waves-effect waves-green btn-flat">{ getLangText("export")}</a></div>
        <div class="col s4"><a href="#" onclick={ openImportAllDataDialog }
          class="waves-effect waves-green btn-flat">{ getLangText("import")}</a></div>
      </div>
    </div>
  </div>
  <script>
    var remote = require('electron').remote
    var self = this
    self.on("mount", function(){
      self.initTooltip()
      $("#export-import-dialog").openModal({
        complete: function() {
          self.unmountDialog();
        }
      });
    })
    RiotControl.on("export_import_close",function(){
      $("#export-import-dialog").closeModal({
        complete: function() {
          self.unmountDialog();
        }
      });
    })
    openExportBookDialog(){
      self.mountDialog("export-book-dialog")
    }
    openImportBookDialog(){
      self.mountDialog("import-dialog",{
        title: self.getLangText("import_book_dialog"),
        filter: {name: self.getLangText("book"), extensions: ['dmb']},
        callback: function(filename){
          RiotControl.one("book_imported",function(err){
            if(!err){
              alert(self.getLangText("import_book_success"))
              RiotControl.trigger("export_import_close")
              RiotControl.trigger("import_close")
            }
            else
              alert(err)
            RiotControl.trigger("progress_finish")
          })
          RiotControl.trigger("progress_start")
          RiotControl.trigger("book_import",filename)
        }
      })
    }
    openExportCardTypeDialog(){
      self.mountDialog("export-cardtype-dialog")
    }
    openImportCardTypeDialog(){
      self.mountDialog("import-dialog",{
        title: self.getLangText("import_cardtype_dialog"),
        filter: {name: self.getLangText("cardtype"), extensions: ['dmc']},
        callback: function(filename){
          RiotControl.one("category_imported",function(err){
            if(!err){
              alert(self.getLangText("import_cardtype_success"))
              RiotControl.trigger("export_import_close")
              RiotControl.trigger("import_close")
            }
            else
              alert(err)
            RiotControl.trigger("progress_finish")
          })
          RiotControl.trigger("progress_start")
          RiotControl.trigger("category_import",filename)
        }
      })
    }
    openExportStoryDialog(){
      self.mountDialog("export-story-dialog")
    }
    openImportStoryRelateDialog(title, fileExt){
      RiotControl.one("book_current_got",function(bookId){
        if(!bookId)
          alert(self.getLangText("please_select_a_book"))
        else{
          self.mountDialog("import-dialog",{
            title: self.getLangText("import_story_relate_dialog",[self.getLangText(title)]),
            filter: {name: self.getLangText(title), extensions: [fileExt]},
            callback: function(filename){
              RiotControl.one("story_imported",function(err){
                if(!err){
                  alert(self.getLangText("import_story_success"))
                  RiotControl.trigger("export_import_close")
                  RiotControl.trigger("import_close")
                }
                else
                  alert(err)
                RiotControl.trigger("progress_finish")
              })
              RiotControl.trigger("progress_start")
              RiotControl.trigger("story_import",{
                filename: filename,
                book_id: bookId
              })
            }
          })
        }
      })
      RiotControl.trigger("book_current_get")
    }
    openImportStoryDialog(e){
      self.openImportStoryRelateDialog("story","dms")
    }
    openExportMapDialog(e){
      self.mountDialog("export-map-dialog")
    }
    openImportMapDialog(e){
      self.openImportStoryRelateDialog("map","dmm")
    }
    openExportMemoDialog(e){
      self.mountDialog("export-memo-dialog")
    }
    openImportMemoDialog(e){
      self.openImportStoryRelateDialog("memo","dmo")
    }

    genExportAllFileName(){
      var curDateStr = Date.today().toString('yyyyMMdd')
      return "all_"+curDateStr+".dma"
    }
    openExportAllDataDialog(e){
      var dialog = remote.dialog;
      dialog.showSaveDialog({
        defaultPath: self.genExportAllFileName(),
        properties: ['openDirectory']
      },function(filePath){
        if(filePath){
          RiotControl.one("book_exported_all",function(err){
            if(err)
              alert(err)
            else
              alert(self.getLangText("export_book_success"))
            RiotControl.trigger("progress_finish")
          })
          RiotControl.trigger("book_export_all",{ file_path: filePath })
          RiotControl.trigger("progress_start")
        }
      })
    }
    openImportAllDataDialog(e){
      self.mountDialog("import-dialog",{
        title: self.getLangText("import_all_data_dialog"),
        filter: {name: self.getLangText("all_data"), extensions: ['dma']},
        callback: function(filename){
          RiotControl.one("book_imported_all",function(err){
            if(!err){
              alert(self.getLangText("import_book_success"))
              RiotControl.trigger("export_import_close")
              RiotControl.trigger("import_close")
            }
            else
              alert(err)
            RiotControl.trigger("progress_finish")
          })
          RiotControl.trigger("progress_start")
          RiotControl.trigger("book_import_all",filename)
        }
      })
    }
  </script>
</export-import-dialog>
