<!--
- dialog for export presentation to type and session (pdf, html, etc..)
- @copyright VTM Corp 2016
-->
<export-present-dialog>
  <style>
    .custCol{
      margin-left: auto;
      left: auto;
      right: auto;
    }
    .colMap{
      margin-top: 80px;
    }
    .colMemo{
      margin-top: 80px;
    }
  </style>
  <div id="export-present-dialog" class="modal">
    <div class="modal-content">
      <h4 class="center-align">{ getLangText("export_present_dialog")}</h4>
      <div class="row">
        <div class="col custCol colType">
          <p>
            <input name="export_type" type="radio" id="exportPdf" checked="checked"/>
            <label for="exportPdf">PDF</label>
          </p>
          <p>
            <input name="export_type" type="radio" id="exportHtml" />
            <label for="exportHtml">HTML</label>
          </p>
          <p>
            <input name="export_type" type="radio" id="exportJson" />
            <label for="exportJson">JSON</label>
          </p>
          <p>
            <input name="export_type" type="radio" id="exportPowerPoint" disabled="disabled"/>
            <label for="exportPowerPoint">{ getLangText("export_present_power_point")}</label>
          </p>
          <p>
            <input name="export_type" type="radio" id="exportExcel" disabled="disabled"/>
            <label for="exportExcel">{ getLangText("export_present_excel")}</label>
          </p>
          <p>
            <input name="export_type" type="radio" id="exportClipboard" />
            <label for="exportClipboard">{ getLangText("export_present_clipboard")}</label>
          </p>
        </div>
        <div class="col custCol colBookStory">
          <p>
            <input type="checkbox" class="filled-in" id="showCover" checked="checked" />
            <label for="showCover">{ getLangText("export_present_show_cover")}</label>
          </p>
          <p>
            <input type="checkbox" class="filled-in" id="showIndex" checked="checked" />
            <label for="showIndex">{ getLangText("export_present_show_index")}</label>
          </p>
          <p>
            <input type="checkbox" class="filled-in" id="showStoryName" checked="checked" />
            <label for="showStoryName">{ getLangText("export_present_show_story_name")}</label>
          </p>
          <p>
            <input type="checkbox" class="filled-in" id="showStoryDesc" checked="checked" />
            <label for="showStoryDesc">{ getLangText("export_present_show_story_desc")}</label>
          </p>
          <p>
            <input type="checkbox" class="filled-in" id="showCard" checked="checked" />
            <label for="showCard">{ getLangText("export_present_show_card")}</label>
          </p>
          <p>
            <input type="checkbox" class="filled-in" id="showCardDesc1" checked="checked" />
            <label for="showCardDesc1">{ getLangText("export_present_show_card_desc1")}</label>
          </p>
          <p>
            <input type="checkbox" class="filled-in" id="showCardDesc2" checked="checked" />
            <label for="showCardDesc2">{ getLangText("export_present_show_card_desc2")}</label>
          </p>
        </div>
        <div class="col custCol colMap">
          <p>
            <input type="checkbox" class="filled-in" id="showMapName" checked="checked" />
            <label for="showMapName">{ getLangText("export_present_show_map_name")}</label>
          </p>
          <p>
            <input type="checkbox" class="filled-in" id="showMapCard" checked="checked" />
            <label for="showMapCard">{ getLangText("export_present_show_map_card")}</label>
          </p>
          <p>
            <input type="checkbox" class="filled-in" id="showMapConnector" checked="checked" />
            <label for="showMapConnector">{ getLangText("export_present_show_map_connector")}</label>
          </p>
        </div>
        <div class="col custCol colMemo">
          <p>
            <input type="checkbox" class="filled-in" id="showMemoName" checked="checked" />
            <label for="showMemoName">{ getLangText("export_present_show_memo_name")}</label>
          </p>
          <p>
            <input type="checkbox" class="filled-in" id="showMemoCard" checked="checked" />
            <label for="showMemoCard">{ getLangText("export_present_show_memo_card")}</label>
          </p>
        </div>
      </div>
    </div>
    <div class="modal-footer">
      <a href="#" class="waves-effect waves-green btn"
        onclick={ doExportPresent }>OK</a>
      <a href="#" class="btn-floating waves-effect waves-green right blue-grey lighten-2"
        style="margin-top: 5px !important; margin-right: 20px" onclick={ showHelp }>
        <i class="material-icons">help_outline</i>
      </a>
    </div>
  </div>
  <script>
    var self = this
    self.on("mount", function(){
      $("#export-present-dialog").openModal({
        complete: function() {
          self.unmountDialog();
        }
      });
    })
    doExportPresent(){
      var exportType = $("[name=export_type]:checked")
                          .attr("id")
                          .replace("export","")
                          .toLowerCase()
      var exportOptions = {}
      var $elmOpts = $(".filled-in:checked")
      $elmOpts.each(function(){
        exportOptions[$(this).attr("id")] = true
      })

      if(Object.keys(exportOptions).length <= 0)
        alert(self.getLangText("export_option_must_select"))
      else
        self.openExportPresentDialog(exportType, exportOptions)
    }
    openExportPresentDialog(type, options){
        self.mountDialog("export-present-detail-dialog",{type:type, options: options})
    }
    showHelp(){
      self.mountDialog("export-present-help-dialog")
    }
  </script>
</export-present-dialog>
