<!--
- dialog for select font option like name, size, style etc...
- @copyright VTM Corp 2016
-->
<font-setting-dialog>
  <div id="font-setting-dialog" class="modal">
    <div class="modal-content">
      <div class="row">
        <div class="col s12 center-align">
          <h4>{ getLangText("font_setting") }</h4>
        </div>
      </div>
      <div class="row">
        <div class="input-field col s3">
          <select class="font-name">
            <option each={ settings.font_names } value={ code }
              selected={ code == contentItem.font_name }>{ name }</option>
          </select>
          <label class="tooltipped" data-position="bottom" data-tooltip={ getLangText("tt_font_name") }>
            { getLangText("font") }</label>
        </div>
        <div class="input-field col s3">
          <select class="color">
            <option each={ settings.colors } value={ code }
              selected={ code == contentItem.color }>{ name }</option>
          </select>
          <label class="tooltipped" data-position="bottom" data-tooltip={ getLangText("tt_font_color") }>
            { getLangText("color") }</label>
        </div>
        <div class="input-field col s3">
          <select class="orientation" disabled={ type=="link_item" }>
            <option each={ settings.text_orientations } value={ code }
              selected={ code == contentItem.orientation }>{ name }</option>
          </select>
          <label class="tooltipped" data-position="bottom" data-tooltip={ getLangText("tt_font_orientation") }>
            { getLangText("text_orientation") }</label>
        </div>
        <div class="input-field col s3">
          <select class="vertical_text_mode" disabled={ type=="link_item" }>
            <option each={ settings.vertical_text_modes } value={ code }
              selected={ code == contentItem.text_mode }>{ name }</option>
          </select>
          <label class="tooltipped" data-position="bottom" data-tooltip={ getLangText("tt_font_vertical_mode") }>
            { getLangText("vertical_text_mode") }</label>
        </div>
      </div>
      <div class="row">
        <div class="input-field col s3">
          <select class="font-size">
            <option each={ settings.font_sizes } value={ code }
              selected={ contentItem.font_size?code==contentItem.font_size:code==settings.font_size_default }>{ name }</option>
          </select>
          <label class="tooltipped" data-position="bottom" data-tooltip={ getLangText("tt_font_size") }>
            { getLangText("font_size") }</label>
        </div>
        <div class="input-field col s3">
          <select class="autofit" disabled={ type=="link_item" }>
            <option each={ settings.autofit } value={ code }
              selected={ code==contentItem.autofit}>{ name }</option>
          </select>
          <label class="tooltipped" data-position="bottom" data-tooltip={ getLangText("tt_font_autofit") }>
            { getLangText("autofit") }</label>
        </div>
        <div class="input-field col s3">
          <select class="position" disabled={ type=="link_item" }>
            <option each={ settings.positions } value={ code }
              selected={ contentItem.position?code==contentItem.position:code==settings.position_default }>{ name }</option>
          </select>
          <label class="tooltipped" data-position="bottom" data-tooltip={ getLangText("tt_font_position") }>
            { getLangText("position") }</label>
        </div>
        <div class="input-field col s3">
          <select class="stylist">
            <option each={ settings.styles } value={ code }
              selected={ contentItem.style?code==contentItem.style:code==settings.style_default }>{ name }</option>
          </select>
          <label class="tooltipped" data-position="bottom" data-tooltip={ getLangText("tt_font_style") }>
            { getLangText("style") }</label>
        </div>
      </div>
    </div>
    <div class="modal-footer">
      <a href="#" class="tooltipped modal-action modal-close waves-effect waves-green btn" onclick={ saveFont }
        data-position="top" data-tooltip={ getLangText("tt_font_save") }>{ getLangText("ok") }</a>
    </div>
  </div>

  <script>
    var self = this
    self.settings = null
    self.contentItem = self.opts.item
    self.type = self.opts.type||"card_item"
    self.on("mount",function(){
      RiotControl.one("font_settings_got",function(font_settings){
        $("#font-setting-dialog").openModal({
          complete: function() {
            self.unmountDialog()
          }
        })
        self.settings = font_settings
        self.update()
      })
      RiotControl.trigger("font_settings_get")
    })
    self.on("updated",function(){
      self.initTooltip()
      $('select').material_select();
    })
    saveFont(){
      self.contentItem.font_name = $("select.font-name").val()
      self.contentItem.color = $("select.color").val()
      self.contentItem.orientation = $("select.orientation").val()
      self.contentItem.text_mode = $("select.vertical_text_mode").val();
      self.contentItem.font_size = $("select.font-size").val();
      self.contentItem.autofit = $("select.autofit").val();
      self.contentItem.position = $("select.position").val();
      self.contentItem.style = $("select.stylist").val();
      RiotControl.trigger("cart_type_item_update",self.contentItem);
    }
  </script>
</font-setting-dialog>
