<!--
- dialog for select import file
- @copyright VTM Corp 2016
-->
<import-dialog>
  <div id="import-dialog" class="modal">
    <div class="modal-content">
      <h4 class="center-align">{ opts.title }</h4>
      <div class="row import-file-name">
        <label>{ getLangText("import_file_name")}</label>
        <input readonly type="text" class="file-name tooltipped" value={ fileImportName }
          data-position="bottom" data-tooltip={ getLangText("tt_import_file") }>
        <a href="#" class="btn-float btn-upload" onclick={ selectFile }><i class="material-icons">cloud_upload</i></a>
      </div>
      <div class="row btn-run">
        <a href="#" class="btn" show={ fileImportName!="" } onclick={ clickRun }>{ getLangText("run")}</a>
      </div>
    </div>
  </div>
  <script>
    var remote = require('electron').remote
    var self = this
    self.fileImportName = ""
    self.filePath = ""

    self.on("mount", function(){
      self.initTooltip()
      $("#import-dialog").openModal({
        complete: function() {
          self.unmountDialog();
        }
      });
    })
    RiotControl.on("import_close",function(){
      $("#import-dialog").closeModal({
        complete: function() {
          self.unmountDialog();
        }
      });
    })
    selectFile(){
      var dialog = remote.dialog;
      dialog.showOpenDialog(
        {filters: [self.opts.filter]},
        function(filenames){
          if(filenames && filenames.length > 0){
            self.filePath = filenames[0]
            self.fileImportName = self.filePath.replace(/^.*[\\\/]/, '')
            self.update()
          }
        })
    }
    clickRun(){
      if(self.filePath)
        self.opts.callback(self.filePath)
    }

  </script>
</import-dialog>
