<!--
- dialog for select language display
- @copyright VTM Corp 2016
-->
<languages-dialog>
  <div id="languages-dialog" class="modal">
    <div class="modal-content">
      <div class="row">
        <div class="col s12 center-align">
          <h4>{ getLangText("language_setting") }</h4>
        </div>
      </div>
      <div class="row">
        <div class="input-field col s3">
          <select class="language-name">
            <option each={ languages } value={ code }
              selected={ code == parent.currentLanguageCode }>{ name }</option>
          </select>
          <label class="tooltipped" data-position="bottom" data-tooltip={ getLangText("tt_language_title") }>
            { getLangText("language_name") }</label>
        </div>
      </div>
    </div>
    <div class="modal-footer">
      <a href="#" class="modal-action modal-close waves-effect waves-green btn" onclick={ saveLanguage }>{ getLangText("ok") }</a>
    </div>
  </div>
  <script>
    var self = this
    self.languages = null
    self.currentLanguageCode = null

    self.on("mount",function(){
      self.initTooltip()
      $("#languages-dialog").openModal({
        complete: function() {
          self.unmountDialog();
        }
      });
      RiotControl.one("languages_setting_got", function(languages){
        RiotControl.one("current_language_got", function(language_code){
          self.languages = languages
          self.currentLanguageCode = language_code
          self.update()
        })
        RiotControl.trigger("current_language_get")
      })
      RiotControl.trigger("languages_setting_get")
    })
    self.on("updated",function(){
      $('select').material_select();
    })
    saveLanguage(){
      var currLangCode = $("select.language-name").val()
      if(currLangCode != self.currentLanguageCode){
        RiotControl.one("current_language_updated",function(){
          var remote = require('electron').remote
          remote.getCurrentWindow().reload();
        })
        RiotControl.trigger("current_language_update", currLangCode)
      }
    }
  </script>
</languages-dialog>
