<!--
- dialog for select the link(relate) story(memo) of card
- @copyright VTM Corp 2016
-->
<link-add-dialog>
  <div id="link-add-dialog" class="modal">
    <div class="modal-content">
      <h4 class="center-align">{ getLangText("link_add_title")}</h4>
      <div class="row">
        <div if={ type=="card"} class="col s5">
          <label>{ getLangText("from_card") }</label>
          <card data={ card }></card>
        </div>
        <div if={ type=="memo"} class="col s5">
          <label>{ getLangText("from_memo") }</label>
          <div class="memo-item">
            <rtf-content content={ card.content } ></rtf-content>
            <div class="overlay-panel"></div>
          </div>
        </div>
        <div class="col s1">
          <i class="material-icons link-icon">link</i>
        </div>
        <div class="col s6">
          <label>{ getLangText("link_to") }</label>
          <div class="row tooltipped" data-position="bottom" data-tooltip={ getLangText("tt_link_set") }>
            <div class="book-tree-dialog"></div>
          </div>
          <div class="row">
            <a href="#" class="tooltipped btn text-blue modal-action modal-close" onclick={ addStory }
              data-position="bottom" data-tooltip={ getLangText("tt_link_story_add") }>
              <i class="material-icons left">add</i>{ getLangText("add_story") }</a>
          </div>
        </div>
      </div>
    </div>
    <div class="modal-footer">
      <a href="#" class="modal-action modal-close waves-effect waves-green btn tooltipped" onclick={ saveCard }
        data-position="top" data-tooltip={ getLangText("tt_link_save") }>{ getLangText("ok") }</a>
    </div>
  </div>
  <script>
    var self = this
    self.bookTree = null
    self.card = self.opts.card
    self.story = self.opts.story
    self.type = self.opts.type?self.opts.type:"card"

    self.on("mount", function(){
      self.initTooltip()
      $("#link-add-dialog").openModal({
        complete: function() {
          self.unmountDialog();
        }
      });
      RiotControl.one("book_link_got", self.showBookStory)
      RiotControl.trigger("book_link_get")
    })

    showBookStory(bookStorylink){
      self.bookTree = $('.book-tree-dialog')
        .tree({
          data: bookStorylink
        })
        .on('tree.click',function(e){
            e.preventDefault();
            var selected_node = e.node;
            if(e.node.id.toString().indexOf('book')<0) //only link to story
              if (self.bookTree.tree('isNodeSelected', selected_node)) {
                  self.bookTree.tree('removeFromSelection', selected_node);
              }
              else {
                  self.bookTree.tree('addToSelection', selected_node);
              }
        });
      $.each(self.card.links, function(index, story_id){
        var node = self.bookTree.tree("getNodeById",story_id);
        self.bookTree.tree('addToSelection', node);
      });
    }
    saveCard(){
      var nodes = self.bookTree.tree('getSelectedNodes');
      var links = [];
      $.each(nodes,function(index, node){
        links.push(node.id)
      })
      self.card.links = links
      RiotControl.trigger('card_update', self.card)
    }
    addStory(){
      RiotControl.trigger('story_add', 'story', self.story._id)
    }
  </script>
</link-add-dialog>
