<!--
- dialog for show link story(memo) of card
- @copyright VTM Corp 2016
-->
<link-dialog>
  <div id="link-dialog" class="modal">
    <div class="modal-content">
      <h4 class="center-align">{ getLangText("link_title")}</h4>
      <ul class="collection list-category list-link tooltipped"
        data-position="bottom" data-tooltip={ getLangText("tt_link_goto") }>
        <li each={ linkDetails } class="collection-item" onclick={ selectStory }>
          <div class="linkitem">
            <i class="linkitem--icon material-icons">link</i>
            <div class="linkitem--contentwrapper">
              <div class="linkitem--path">{ parent_path }</div>
              <div class="linkitem--name">{ story_name }</div>
            </div>
          </div>
        </li>
      </ul>
      <div class="book-tree-dialog" style="display:none"></div>
    </div>
  </div>
  <script>
    var self = this
    self.linkDetails = []

    self.on("mount", function(){
      self.initTooltip()
      $("#link-dialog").openModal({
        complete: function() {
          self.unmountDialog();
        }
      });
      RiotControl.one("books_inited", self.showBookStory)
      RiotControl.trigger("books_init")
    })

    showBookStory(bookStorylink){
      self.bookTree = $('.book-tree-dialog')
        .tree({
          data: bookStorylink
        })
      var links = self.opts.card.links
      $.each(links,function(index, story_id){
        var node = self.bookTree.tree("getNodeById", story_id)
        if(node){
          var nodePath = "",
            parentNode = node
          while(parentNode.getLevel() > 1){
            parentNode = parentNode.parent;
            nodePath = parentNode.name + " ＞ " + nodePath
          }
          self.linkDetails.push({
            story_id: story_id,
            book_id: parentNode.id,
            story_name: node.name,
            parent_path: nodePath
          })
        }
        if(self.linkDetails.length == 0)
          RiotControl.trigger("card_update",self.opts.card)
      })
      self.update()
    }
    selectStory(e){
      $("#link-dialog").closeModal({
        complete: function() {
          self.unmountDialog();
          RiotControl.trigger('story_select', e.item.story_id, e.item.book_id)
        }
      });
    }
  </script>
</link-dialog>
