<!--
- dialog for show list card type to delete, update
- @copyright VTM Corp 2016
-->
<list-card-type-dialog>
  <div id="list-card-type-dialog" class="modal">
    <div class="modal-content">
      <h4 class="center-align">{ getLangText("list_card_type_title")}</h4>
      <a href="#" class="tooltipped btn-card-type-create btn-floating waves-effect waves-red red-text"
        onclick={ addCardType } data-position="bottom" data-tooltip={ getLangText("tt_card_type_add") }>
        <i class="material-icons">add</i></a>
      <div class="row">
        <div class="col s9">
          <div class="list-card-type2">
            <ol class="grid">
              <li each={ card_type, card_type_index in card_types }
                class={ card-type-item:true, active: card_type_index==parent.selectingCardIndex }
                onclick={ selectCard } data-position={ card_type_index }>
                <card-type data={ card_type }></card-type>
                <div class="card-type-label-wrapper">
                  <div class="title">{ card_type.name }</div>
                  <a href="#" class="tooltipped btn-edit btn-flat waves-effect waves-green green-text" onclick={ editCard }
                    data-position="bottom" data-tooltip={ getLangText("tt_card_type_edit") }>
                    <i class="material-icons">edit</i></a>
                  <a href="#" class="tooltipped btn-remove btn-flat waves-effect waves-red red-text"
                      show={ card_types.length > 1 } onclick={ removeCard }
                      data-position="bottom" data-tooltip={ getLangText("tt_card_type_delete") }>
                    <i class="material-icons">delete</i></a>
                </div>
              </li>
            </ol>
          </div>
        </div>
        <div class="col s3">
          <ul class="tooltipped collection list-category" data-position="bottom" data-tooltip={ getLangText("tt_card_type_cate_select") }>
            <li each={ category, category_index in categories } class={ collection-item:true, active:category_index==parent.selectingCategoryIndex }
              onclick={ selectCategory }>{ category.name }</li>
          </ul>
        </div>
      </div>
    </div>
  </div>
  <script>
    var self = this
    self.card_types = null
    self.selectingCardIndex = 0
    self.categories = null
    self.selectingCategoryIndex = 0
    self.type=self.opts.type

    self.on("mount", function(){
      $("#list-card-type-dialog").openModal({
        complete: function() {
          self.unmountDialog();
        }
      });
      RiotControl.off('categories_got')
      RiotControl.one('categories_got',function(categories){
        if(self.selectingCategoryIndex >= categories.length){
          self.selectingCategoryIndex = categories.length-1
          self.selectingCardIndex = 0
        }
        if(self.selectingCategoryIndex < 0)
          self.selectingCategoryIndex = 0
        self.categories = categories

        RiotControl.off('card_types_got')
        RiotControl.one('card_types_got',self.doGotCard)
        RiotControl.trigger('card_types_get',self.type, self.categories[self.selectingCategoryIndex]._id)

        self.update()
      })
      RiotControl.trigger('categories_get',self.type)
    })
    self.on("updated",function(){
      self.initTooltip()
      $('.list-card-type2 > ol').sortable({
          onDrop: function ($item, container, _super, event) {
            $item.removeClass(container.group.options.draggedClass).removeAttr("style")
            $("body").removeClass(container.group.options.bodyClass)

            var new_card_items = []
            var index = 0;
            container.el.find("> li").each(function(){
              var item = self.card_types[$(this).data("position")];
              item.order = index
              $(this).data("position",index)
              new_card_items.push(item)
              index++
            })
            self.card_types = new_card_items
            self.updateOrder()
          }
      })
    })
    doGotCard(card_types){
      self.selectingCardIndex = 0
      self.card_types = card_types
      self.update()
    }
    updateOrder(){
      RiotControl.off("card_types_updated")
      RiotControl.one("card_types_updated", function(){
        RiotControl.one('card_types_got',self.doGotCard)
        RiotControl.trigger('card_types_get',self.type, self.categories[self.selectingCategoryIndex]._id)
      })
      RiotControl.trigger("card_types_update", self.type, self.card_types)
    }
    isInCardList(cardType){
      for(var i=0; i<self.card_types.length; i++)
        if(cardType._id == self.card_types[i]._id)
          return true
      return false
    }
    selectCategory(e){
      self.selectingCategoryIndex = e.item.category_index;
      RiotControl.off('card_types_got')
      RiotControl.one('card_types_got',self.doGotCard)
      RiotControl.trigger('card_types_get',self.type, self.categories[self.selectingCategoryIndex]._id)
    }
    selectCard(e){
      self.selectingCardIndex = e.item.card_type_index
    }
    editCard(e){
      RiotControl.off('card_type_updated')
      RiotControl.one('card_type_updated',function(card_type){
        self.card_types.splice(self.selectingCardIndex,1,card_type)
        for(var i=0; i<self.card_types.length; i++)
          self.card_types[i].order = i
        self.updateOrder()
        self.update()
      })
      self.mountDialog("card-type-dialog",{card:e.item.card_type, type: self.type})
    }
    removeCard(e){
      self.card_types.splice(e.item.card_type_index,1)
      RiotControl.trigger('card_type_remove', self.type, e.item.card_type._id)
    }
    addCardType(){
      var category_id = self.categories[self.selectingCategoryIndex]._id;
      RiotControl.one('default_card_type_got',function(card_type){
        card_type.category_id = category_id
        RiotControl.off('card_type_updated')
        RiotControl.one('card_type_updated',function(card_type){
          RiotControl.one('card_types_got',self.doGotCard)
          RiotControl.trigger('card_types_get',self.type, self.categories[self.selectingCategoryIndex]._id)
        })
        self.mountDialog("card-type-dialog",{card:card_type, type: self.type});
      })
      RiotControl.trigger('default_card_type_get',self.type)
    }
  </script>
</list-card-type-dialog>
