<!--
- show map content
- @copyright VTM Corp 2016
-->
<map>
  <div class="row">
    <div class="col s8">
      <b><input type="text" name="title" class="map_title" onkeyup={ changeTitle }></b>
    </div>
    <div class="col s4 right-align">
      <a class="btn btn-large btn-move" style="padding:0;" onclick={ changeMode }>
        <i class="material-icons left" style="margin: auto 15px;">pan_tool</i></a>
      <a class="btn btn-large btn-connect disabled" style="padding:0;" onclick={ changeMode }>
        <i class="material-icons left" style="margin: auto 15px;">call_made</i></a>
    </div>
  </div>
  <div class="map-item-list" onclick={ selectBackground }>
    <div each={ connection, connect_id in mapDetailData.links}>
      <connection shape={connection.shape}
        from={parent.getCardById(connection.connect.fromId) }
        to={parent.getCardById(connection.connect.toId)}
        ondblclick={editConnection}>
      </connection>
    </div>
    <div each={ map_item, card_index in mapDetailData.map_items } data-position={ card_index }
      class={map-item:true, draggable:true, active:parent.selectingItemIndex!==null&&parent.selectingItemIndex==card_index} id={ map_item.id }
      style={ "transform: translate("+map_item.x+"px, "+map_item.y+"px);" }>
      <card data={ map_item } ondblclick={ editCard } onclick={ parent.selectCard }></card>
      <div class="group-action tooltipped group-action-map" data-position="bottom" data-tooltip={ getLangText("tt_story_menu") }>
        <a class={btn-floating:true, btn-large:true, lighten-1:true, btn-action-door:true, grey:!map_item.links||map_item.links.length<=0, blue:map_item.links.length>0 }>
          <i class="large material-icons">
            more_vert</i>
        </a>
        <ul>
          <li><a class="btn green" onclick={ removeCard }><i class="material-icons">delete</i></a><label>{ getLangText("remove") }</label></li>
          <li><a class="btn blue" onclick={ editCard }><i class="material-icons">mode_edit</i></a><label>{ getLangText("edit") }</label></li>
          <li><a class="btn yellow darken-1" onclick={ addLink }><i class="material-icons">link</i></a><label>{ getLangText("link") }</label></li>
          <li show={ map_item.links.length > 0 }>
            <a class="btn lighten-2 blue" onclick={ openLinkDialog }>
              <i class="material-icons">trending_flat</i>
            </a>
            <label>{ getLangText("linkto") }</label>
          </li>
        </ul>
      </div>
    </div>
  </div>
  <div class="clearfix"></div>
  <a href="#" class="btn-card-add btn-floating waves-effect btn-large red" onclick={ addCard }>
    <i class="material-icons">add</i></a>
  <script>
    require("interact.js")
    var uuid = require('node-uuid')
    var self = this
    self.mapDetailData = null
    self.selectingItemIndex = null
    self.currentMode="move"
    self.lastSelectItem=null
    self.defaultConnection=null

    getCardById(id){
      var mapItems=self.mapDetailData.map_items
      for(var i=0;i<mapItems.length;i++)
        if(mapItems[i].id==id)
          return mapItems[i]
      return null
    }
    changeMode(e){
      $(".btn-move,.btn-connect").removeClass("disabled")
      if(self.currentMode=="move"){
        self.currentMode="connect"
        $(".btn-move").addClass("disabled")
      }
      else{
        self.currentMode="move"
        $(".btn-connect").addClass("disabled")
        self.selectingItemIndex=null
      }
      if(e) e.preventUpdate=true
    }
    self.on("update",function(){
      if(self.opts.type == "map"){ //specify filter, due to riot bug which conditionals attributes on custom nested tags does not stop riot from evaluating the hidden expressions
        self.mapDetailData = self.opts.map;
      }
    })
    self.on("updated",function(){
      if(self.opts.type != "map") return
      if(self.mapDetailData && self.mapDetailData.name != $('.map_title').val())
        $('.map_title').val(self.mapDetailData.name);
      interact(".map-item-list .draggable")
        .draggable({
          // enable inertial throwing
          //inertia: true,
          // keep the element within the area of it's parent
          restrict: {
            restriction: "parent",
            endOnly: true,
            elementRect: { top: 0, left: 0, bottom: 1, right: 1 }
          },
          // call this function on every dragmove event
          onmove: function(event){
            if(self.currentMode!="move") return
            var target = event.target,
                pos = parseInt(target.getAttribute("data-position")),
                item = self.mapDetailData.map_items[pos]

            item.x = (item.x || 0) + event.dx
            item.y = (item.y || 0) + event.dy

            // translate the element
            target.style.webkitTransform =
            target.style.transform =
              'translate(' + item.x + 'px, ' + item.y + 'px)';

            self.update()
          },
          // call this function on every dragend event
          onend: function (event) {
            if(self.currentMode!="move") return
            self.updateMap()
          }
        })

      $(".group-action .btn-action-door,.group-action ul")
        .off("mouseenter").on("mouseenter",function(){
          var $elm = $(this).closest(".group-action")
          $elm.find("ul").stop(true, false).slideDown();
        })
        .off("mouseleave").on("mouseleave",function(){
          var $elm = $(this).closest(".group-action");
            $elm.find("ul").stop(true, false).slideUp()
        })
    })
    changeTitle(e){
      self.mapDetailData.name = $(e.currentTarget).val()
      RiotControl.trigger("map_update", self.mapDetailData)
      e.preventUpdate = true
    }
    editCard(e){
      var index=e.item.card_index
      RiotControl.off("card_update")
      RiotControl.one("card_update", function(card){
        self.mapDetailData.map_items[index]=$.extend(true,{},card)
        self.mapDetailData.links=$.extend(true,{},{links:self.mapDetailData.links}).links //reupdate all links
        self.updateMap()
      })
      self.mountDialog("card-edit-dialog",{card:e.item.map_item})
    }
    getCoords(elem) {
      var width = elem.width||200,
          height = elem.height||125,
          px = elem.x||0,
          cen = px + (width / 2),
          py = elem.y||0,
          mid = py + (height / 2),
          ret = {
            cc: [cen, mid],
            hw: width/2,
            hh: height/2
          }
      return ret
    };
    cardInsert(connection, card){
      var from=self.getCardById(connection.connect.fromId),
          to=self.getCardById(connection.connect.toId),
          fromCoord=self.getCoords(from),
          toCoord=self.getCoords(to),
          insertCoord=self.getCoords(card)

      do{//move TO card position to place INSERT card
        var disX=Math.abs(fromCoord.cc[0]-toCoord.cc[0])-fromCoord.hw-toCoord.hw,
            disY=Math.abs(fromCoord.cc[1]-toCoord.cc[1])-fromCoord.hh-toCoord.hh
        if(disX>insertCoord.hw*2 || disY>insertCoord.hh*2) break
        to.y+=insertCoord.hh*2
        toCoord.cc[1]+=insertCoord.hh*2
      }while(true)

      card.x=(fromCoord.cc[0]+toCoord.cc[0])/2-insertCoord.hw
      card.y=(fromCoord.cc[1]+toCoord.cc[1])/2-insertCoord.hh
      self.mapDetailData.map_items.push(card)
      connection.connect.toId=card.id
      self.createConnection(card, to)
    }
    updateMap(){
      RiotControl.trigger("map_update", self.mapDetailData)
      self.update()
      self.clearSelection()
    }
    editConnection(e){
      var connect_id=e.item.connect_id
      var connection=self.mapDetailData.links[connect_id]

      //listen on card insert
      RiotControl.off("card_insert")
      RiotControl.one("card_insert",function(card){
        self.cardInsert(connection, card)
        self.updateMap()
      })
      //listen on delete
      RiotControl.off("connection_remove")
      RiotControl.one("connection_remove",function(){
        self.mapDetailData.links.splice(connect_id,1)
        self.updateMap()
      })
      //listen on update
      RiotControl.off("connection_update")
      RiotControl.one("connection_update",function(newShape){
        connection.shape=newShape
        self.mapDetailData.links[connect_id]=$.extend(true,{},connection) //update outer object to update view
        self.updateMap()
      })
      self.mountDialog("connection-edit-dialog", {shape: connection.shape})
    }
    addLink(ev){
      var index = ev.item.map_item_index;
      RiotControl.off("card_update")
      RiotControl.one("card_update", function(card){
        self.mapDetailData.map_items[index]=$.extend(true,{},card)
        self.mapDetailData.links=$.extend(true,{},{links:self.mapDetailData.links}).links //reupdate all links
        self.updateMap()
      })
      self.mountDialog("link-add-dialog",{card:ev.item.map_item, story: self.mapDetailData})
    }
    openLinkDialog(e){
      var map_item = e.item.map_item
      if(map_item.links.length == 1)
        RiotControl.trigger('story_select',map_item.links[0],null)
      else
        self.mountDialog("link-dialog",{card:map_item})
    }
    removeCard(ev){
      var index = ev.item.card_index
      self.mountDialog("confirm-dialog",{
        message: self.getLangText("msg_sure_to_delete"),
        doOK: function(){
          var mapLinks=self.mapDetailData.links,
              removedItem=self.mapDetailData.map_items.splice(index,1)[0]

          for(var i=mapLinks.length-1;i>=0;i--){
            var link=mapLinks[i].connect
            if(link.fromId==removedItem.id||link.toId==removedItem.id)
              mapLinks.splice(i,1)
          }
          self.updateMap()
        }
      })
      ev.preventUpdate=true
    }
    addCard(e){
      RiotControl.off("card_add")
      RiotControl.one("card_add", function(card){
        card.id = uuid.v1()
        self.mapDetailData.map_items.push(card)
        self.updateMap()
      })
      self.mountDialog("card-add-dialog", {type: "map"})
    }
    createConnection(from, to){
      var fromId=from.id,
          toId=to.id,
          mapLinks=self.mapDetailData.links

      for(var i=0; i<mapLinks.length;i++){
        var link=mapLinks[i].connect
        if((link.fromId==fromId&&link.toId==toId)||(link.fromId==toId&&link.toId==fromId)){//if exist, update src dest
          link.fromId=fromId
          link.toId=toId
          mapLinks[i]=$.extend(true,{},mapLinks[i])
          self.updateMap()
          return
        }
      }
      var funcAddConnection=function(){
        var connect=self.defaultConnection
        connect.connect={fromId: fromId, toId: toId}
        mapLinks.push(connect)
        self.mapDetailData.links=$.extend(true,{},{links:self.mapDetailData.links}).links
        self.updateMap()
      }
      if(self.defaultConnection)
        funcAddConnection()
      else{
        RiotControl.one("connection_default_got",function(connection){
          self.defaultConnection = connection
          funcAddConnection()
        })
        RiotControl.trigger("connection_default_get")
      }
    }
    selectCard(e){
      if(self.currentMode=="connect"){
        if(self.selectingItemIndex!==null&&self.selectingItemIndex!=e.item.card_index){
          var map_items = self.mapDetailData.map_items
          self.createConnection(map_items[self.selectingItemIndex],map_items[e.item.card_index])
        }
        self.selectingItemIndex=e.item.card_index
      }
    }
    selectBackground(e){
      if($(e.srcElement).is(".map-item-list"))
        self.selectingItemIndex=null
    }
  </script>
</map>
