<!--
- show memo content
- @copyright VTM Corp 2016
-->
<memo>
  <style>
    .memo-item.card{
      padding: 1px;
    }
  </style>
  <div class="row">
    <div class="col s8">
      <b><input type="text" name="title" class="memo_title" onkeyup={ changeTitle }></b>
    </div>
  </div>
  <div class="memo-item-list">
    <div class="memo-item card draggable" each={ memo_item,memo_item_index in memoDetailData.memo_items }
        ondblclick={ editContent }
        data-position={ memo_item_index }
        style={ "transform: translate("+memo_item.x+"px, "+memo_item.y+"px);"}>
      <div class="card-description show-scroll" style={"width: "+memo_item.width+"px;"+"height: "+memo_item.height+"px; background: "+memo_item.bg_color}>
        <rtf-content content={ memo_item.content }></rtf-content>
      </div>
      <div class="group-action">
        <a class={ btn-floating:true, btn-large:true, lighten-1:true, btn-action-door:true, grey:!memo_item.links||memo_item.links.length<=0, blue:memo_item.links.length>0 }>
          <i class="large material-icons">more_vert</i>
        </a>
        <ul class="memo">
          <li><a class="btn green" onclick={ removeCard }><i class="material-icons">delete</i></a><label>{ getLangText("remove") }</label></li>
          <li><a class="btn blue" onclick={ editContent }><i class="material-icons">mode_edit</i></a><label>{ getLangText("edit") }</label></li>
          <li><a class="btn yellow darken-1" onclick={ addLink }><i class="material-icons">link</i></a><label>{ getLangText("link") }</label></li>
          <li show={ memo_item.links.length > 0 }>
            <a class="btn lighten-2 blue" onclick={ openLinkDialog }>
              <i class="material-icons">trending_flat</i>
            </a>
            <label>{ getLangText("linkto") }</label>
          </li>
        </ul>
      </div>
    </div>
  </div>
  <div class="clearfix"></div>
  <a href="#" class="btn-card-add btn-floating waves-effect btn-large red" onclick={ addCard }>
    <i class="material-icons">add</i></a>
  <script>
    require("interact.js")
    var self = this
    self.memoDetailData = null
    self.selectingItemIndex = 0

    self.on("update",function(){
      if(self.opts.type == "memo"){ //specify filter, due to riot bug which conditionals attributes on custom nested tags does not stop riot from evaluating the hidden expressions
        self.memoDetailData = self.opts.memo;
      }
    })
    self.on("mount",function(){
      interact(".memo-item-list .draggable")
        .draggable({
          // enable inertial throwing
          // keep the element within the area of it's parent
          restrict: {
            restriction: "parent",
            endOnly: true,
            elementRect: { top: 0, left: 0, bottom: 1, right: 1 }
          },
          // call this function on every dragmove event
          onmove: function(event){
            var target = event.target,
                index = parseInt(target.getAttribute('data-position')),
                item=self.memoDetailData.memo_items[index]
            // keep the dragged position in the data-x/data-y attributes
            item.x = (item.x || 0) + event.dx
            item.y = (item.y || 0) + event.dy

            self.update()
          },
          // call this function on every dragend event
          onend: function (event) {
            self.updateMemo()
          }
        })
        .resizable({
          edges: { left: true, right: true, bottom: true, top: true },
          restrict: {
            restriction: "parent"
          }
        })
        .on('resizemove', function(event){

          if(isNaN(event.deltaRect.left)||isNaN(event.deltaRect.top))
            return
          var target = event.target,
              index = parseInt(target.getAttribute('data-position')),
              item=self.memoDetailData.memo_items[index]

          item.width = event.rect.width
          item.height = event.rect.height
          item.x = (item.x||0)+event.deltaRect.left
          item.y = (item.y||0)+event.deltaRect.top

          self.update()
        })
        .on('resizeend', function(event){
          self.updateMemo()
        })
    })
    self.on("updated",function(){
      if(self.opts.type != "memo") return
      if(self.memoDetailData && self.memoDetailData.name != $('.memo_title').val())
        $('.memo_title').val(self.memoDetailData.name);


      $(".group-action .btn-action-door,.group-action ul")
        .off("mouseenter").on("mouseenter",function(){
          var $elm = $(this).closest(".group-action")
          $elm.find("ul").stop(true, false).slideDown();
        })
        .off("mouseleave").on("mouseleave",function(){
          var $elm = $(this).closest(".group-action");
            $elm.find("ul").stop(true, false).slideUp()
        })
    })
    updateMemo(){
      RiotControl.trigger("memo_update", self.memoDetailData)
      self.update()
    }
    changeTitle(e){
      self.memoDetailData.name = $(e.currentTarget).val()
      RiotControl.trigger("memo_update", self.memoDetailData)
      e.preventUpdate = true
    }
    addLink(ev){
      var index = ev.item.memo_item_index;
      RiotControl.off("card_update")
      RiotControl.one("card_update", function(card){
        self.updateMemo()
      })
      self.mountDialog("link-add-dialog",{card:ev.item.memo_item, story: self.memoDetailData, type: "memo"})
    }
    openLinkDialog(e){
      var memo_item = e.item.memo_item
      if(memo_item.links.length == 1)
        RiotControl.trigger('story_select',memo_item.links[0],null)
      else
        self.mountDialog("link-dialog",{card:memo_item})
    }
    removeCard(ev){
      self.mountDialog("confirm-dialog",{
        message: self.getLangText("msg_sure_to_delete"),
        doOK: function(){
          var index = ev.item.memo_item_index
          self.memoDetailData.memo_items.splice(index,1)
          self.updateMemo()
        }
      })
    }
    addCard(){
      RiotControl.trigger("memo_item_add", self.memoDetailData)
    }
    editContent(ev){
      var item = ev.item.memo_item
      RiotControl.off("richtext_updated")
      RiotControl.one("richtext_updated",function(data){
        item.content = data.content
        item.bg_color = data.bg_color
        self.updateMemo()
      })
      self.mountDialog("richtext-dialog",{content:item.content, type: "memo", bg_color: item.bg_color})
    }
    getStyle(item){
      //"transform: translate("+memo_item.x+"px, "+memo_item.y+"px);"
      var res="transform: translate("+item.x+"px, "+item.y+"px);"+
              "width: "+item.width+"px;"+
              "height: "+item.height+"px;"
      return res
    }
  </script>
</memo>
