<!--
- tap bar manage
- @copyright VTM Corp 2016
-->
<openingstories>
  <ul class="tabs">
    <li each={ tab,index  in openingTags } class="tab" style="position:relative">
      <a href="#" class={ active: index == parent.currSelectingPos } onclick={ changeTab }>
        <div class="grey-text">{ tab.content.name }</div></a>
      <div class="btn-flat btn-close-tab" onclick={ closeTab }>x</div>
    </li>
  </ul>
  <script>
    self = this;
    self.openingTags = [];
    self.currSelectingPos = 0;
    RiotControl.on('book_selected', function(book){
        self.selectTab('book',book);
    })
    RiotControl.on('story_selected',function(story){
        self.selectTab('story',story);
    })
    RiotControl.on('story_removed',function(story, relateDeleteStoryIds){
      self.deleteTab('story',story,relateDeleteStoryIds);
    })
    RiotControl.on('book_removed',function(book, relateDeleteStoryIds){
      self.deleteTab('book',book,relateDeleteStoryIds);
    })
    RiotControl.on('story_updated',function(story){
      self.updateTab("story",story)
    })
    RiotControl.on('book_updated',function(book){
      self.updateTab("book",book)
    })
    this.on('updated',function(){
      $('ul.tabs').tabs();
    })

    updateTab(type, item){
      if(!item) return;
      for(var i = 0; i < self.openingTags.length; i++){
        var tab = self.openingTags[i];
        if(tab.type == type && tab.content._id == item._id){
          tab.content = item;
          self.update();
          return;
        }
      }
    }
    selectTab(type, item){
      if(!item) return;
      for(var i = 0; i < self.openingTags.length; i++){
        var tab = self.openingTags[i];
        if(tab.type == type && tab.content._id == item._id){
          self.currSelectingPos = i;
          self.update();
          return;
        }
      }
      var newTab = {type: type, content: item}
      self.openingTags.push(newTab)
      self.currSelectingPos = self.openingTags.length-1;
      self.update();
    }
    deleteTab(type, item_id, relateDeleteStoryIds){
      var beforeRemoveSize = self.openingTags.length;
      for(var i=0; i < self.openingTags.length; i++){
        var tab = self.openingTags[i];
        if((tab.type == type && tab.content._id == item_id) ||
            (tab.type == "story" && relateDeleteStoryIds.indexOf(tab.content._id)>=0))
          self.openingTags.splice(i,1);
      }
      if(beforeRemoveSize != self.openingTags.length){
        if(self.currSelectingPos >= self.openingTags.length)
          self.currSelectingPos = self.openingTags.length - 1;
        self.doChangeTab(self.openingTags[self.currSelectingPos]);
      }
    }
    closeTab(e){
      var index = e.item.index;
      self.openingTags.splice(index,1);
      if(index < self.currSelectingPos)
        self.currSelectingPos--;
      else if(index == self.currSelectingPos){
        if(self.currSelectingPos >= self.openingTags.length)
          self.currSelectingPos = self.openingTags.length - 1;
      }
      self.doChangeTab(self.openingTags[self.currSelectingPos]);
    }
    doChangeTab(tab){
      if(!tab)
        RiotControl.trigger("book_selected",null)
      else if(tab.type == "book")
        RiotControl.trigger("book_selected",tab.content)
      else
        RiotControl.trigger("story_selected",tab.content)
    }
    changeTab(e){
      self.doChangeTab(e.item.tab);
    }
  </script>
</openingstories>
