<!--
- dialog for edit rich text content
- @copyright VTM Corp 2016
-->
<richtext-dialog>
  <style>
    .rtf-bg-select-wrapper{
      float: left;
      margin-left: 15px;
      margin-top: -20px;
    }
    #richtext-dialog{
      width: 730px;
    }
  </style>
  <div id="richtext-dialog" class="modal">
    <div class="modal-content">
      <div class="richtext-content">
      </div>
    </div>
    <div class="modal-footer">
      <div if={ opts.type=="memo" } class="rtf-bg-select-wrapper">
        <label>{ getLangText("background_color") }</label>
        <select class="browser-default" onchange={ changeBgColor }>
          <option each={ settings.colors } value={ code }
            selected={ code == parent.opts.bg_color }>{ name }</option>
        </select>
      </div>
      <a href="#" class="modal-action modal-close waves-effect waves-green btn" onclick={ saveRichText }>OK</a>
    </div>
  </div>
  <script>
    var self = this
    self.settings = null

    self.on("mount",function(){
      RiotControl.one("richtext_settings_got",function(settings){
        $("#richtext-dialog").openModal({
          complete: function() {
            self.unmountDialog();
          }
        });
        tinymce.init({
          selector: ".richtext-content",
          content_css: "css/tinymce.css",
          menubar: false,
          plugins:['link image textcolor'],
          toolbar: 'insertfile undo redo | styleselect | bold italic | forecolor backcolor |'+
                    'alignleft aligncenter alignright alignjustify | '+
                    'bullist numlist outdent indent | link image',
          height: 320,
          width: 680,
          resize: false,
          init_instance_callback:function(editor){
            var content = self.opts.content || ""
            editor.setContent(content)
            if(self.opts.type=="memo"&&self.opts.bg_color)
              $(editor.getBody()).css("background",self.opts.bg_color)
            self.clearSelection()
          }
        })
        self.settings = settings
        self.one("updated",function(){
          $('select').material_select();
        })
        self.update()
      })
      RiotControl.trigger("richtext_settings_get")
    })
    changeBgColor(e){
      self.opts.bg_color=e.target.value
      $(tinymce.activeEditor.getBody()).css("background",self.opts.bg_color)
    }
    saveRichText(){
      var content = tinymce.activeEditor.getContent()
      tinymce.remove()

      RiotControl.trigger("richtext_updated", {
        content: content,
        type: self.opts.type,
        bg_color: self.opts.bg_color
      })
    }
  </script>
</richtext-dialog>
