<!--
- dialog for select setting options(languages, card type, category, etc...)
- @copyright VTM Corp 2016
-->
<setting-dialog>
  <style>
    .btn-detail-setting{
      padding: 0;
      text-decoration: underline;
    }
    .lb-detail-setting{
      font-size: 0.9em;
      display: block;
      margin-top: 7px;
    }
  </style>
  <div id="setting-dialog" class="modal">
    <div class="modal-content">
      <h4 class="center-align">{ getLangText("setting")}</h4>
      <div class="row">
        <div class="col s2">
          <label class="lb-detail-setting">{ getLangText("card_types") }</label>
        </div>
        <div class="col s2">
          <a href="#" class="waves-effect waves-green btn-flat btn-detail-setting" onclick={ openCardTypeDialogForStory }>{ getLangText("story") }</a>
        </div>
        <div class="col s2">
          <a href="#" class="waves-effect waves-green btn-flat btn-detail-setting" onclick={ openCardTypeDialogForMap }>{ getLangText("map") }</a>
        </div>
      </div>
      <div class="row">
        <div class="col s2">
          <label class="lb-detail-setting">{ getLangText("categories") }</label>
        </div>
        <div class="col s2">
          <a href="#" class="waves-effect waves-green btn-flat btn-detail-setting" onclick={ openCategoryDialogForStory }>{ getLangText("story") }</a>
        </div>
        <div class="col s2">
          <a href="#" class="waves-effect waves-green btn-flat btn-detail-setting" onclick={ openCategoryDialogForMap }>{ getLangText("map") }</a>
        </div>
      </div>
      <div class="row">
        <a href="#" class="waves-effect waves-green btn-flat" onclick={ openLanguageDialog }>{ getLangText("languages") }</a>
      </div>
    </div>
  </div>
  <script>
    var self = this
    self.on("mount", function(){
      $("#setting-dialog").openModal({
        complete: function() {
          self.unmountDialog();
        }
      });
    })
    openCardTypeDialogForStory(e){
      self.mountDialog("list-card-type-dialog",{type: "story"})
    }
    openCardTypeDialogForMap(e){
      self.mountDialog("list-card-type-dialog",{type: "map"})
    }
    openCategoryDialogForStory(e){
      self.mountDialog("category-dialog",{type: "story"})
    }
    openCategoryDialogForMap(e){
      self.mountDialog("category-dialog",{type: "map"})
    }
    openLanguageDialog(e){
      self.mountDialog("languages-dialog")
    }
  </script>
</setting-dialog>
