<!--
- show sidemenu to select book(story)
- @copyright VTM Corp 2016
-->
<sidemenu-panel class="card-panel grey lighten-5 z-depth-0">
  <style>
    .btn-toggle-sidepanel{
      position: absolute;
      top:92px;
      left:10px;
    }
  </style>
  <div class="row">
    <div class="col s1 magic-grid"><a class="tooltipped waves-effect waves-teal btn-toggle-sidepanel btn-flat btn-floating transparent" href="#"
      onclick={ toggleSidePanel } data-position="bottom" data-tooltip={ getLangText("tt_toggle_sidebar") }><i class="material-icons black-text">keyboard_arrow_left</i></a></div>
    <div class="col s1 offset-s6 magic-grid"><a class="tooltipped waves-effect waves-red btn-flat btn-floating transparent" href="#"
      onclick={ delete } data-position="bottom" data-tooltip={ getLangText("tt_delete_data") }><i class="material-icons black-text">delete</i></a></div>
    <div class="col s1 offset-s1 magic-grid"><a class="tooltipped waves-effect waves-red btn-flat btn-floating transparent" href="#"
      onclick={ copy } data-position="bottom" data-tooltip={ getLangText("tt_copy_data") }><i class="material-icons black-text">copyright</i></a></div>
    <div class="col s1 offset-s1 magic-grid"><a class="tooltipped waves-effect waves-red btn-flat btn-floating transparent" href="#"
      onclick={ add_story } data-position="bottom" data-tooltip={ getLangText("tt_add_story_memo") }><i class="material-icons black-text">add</i></a></div>
  </div>
  <div class="divider"></div>
  <div class="row book-content">
    <div class="col s12">
      <div class="book-tree"></div>
    </div>
  </div>
  <div class="divider"></div>
  <br/>
  <div class="row">
    <div class="col s12">
      <a class="tooltipped waves-effect waves-teal btn-flat blue-text" onclick="{ add_book }" data-position="bottom" data-tooltip={ getLangText("tt_add_book") }>{ getLangText("add") }</a>
    </div>
  </div>

  <script>
    var self = this;
    var bookTree;
    RiotControl.on('books_inited',function(bookStorylink){
      self.initTooltip()
      bookTree = $('.book-tree')
        .tree({
          /*
          openedIcon: '-',
          closedIcon: '+',
          */
          dragAndDrop: true,
          onCanMoveTo: function(moved_node, target_node, position) {
            if(moved_node.id.toString().indexOf("book")>=0){
              if(target_node.id.toString().indexOf("book")>=0)
                return position=="before" || position=="after";
              return false;
            }
            else{
              if(target_node.id.toString().indexOf("book")>=0)
                return position=="inside"
              return true;
            }
          }
        })
        .on('tree.click',function(e){
          var node = e.node;
          self.selectItem(node)
        })
        .on('tree.move',function(e){
          e.preventDefault();
          e.move_info.do_move();
          RiotControl.trigger("book_link_update",bookTree.tree("getTree").getData())
        })
        bookTree.tree('loadData', bookStorylink);
        RiotControl.trigger("books_rendered")
    })
    getAllChildrenNodeIds(node){
      var nodeIds = []
      for (var i=0; i < node.children.length; i++) {
        var child = node.children[i]
        nodeIds.push(child.id)
        nodeIds = nodeIds.concat(self.getAllChildrenNodeIds(child))
      }
      return nodeIds
    }
    RiotControl.on('book_removed',function(book_id){
      var book_id = "book" + book_id;
      var node = bookTree.tree("getNodeById",book_id);
      if(node){
        var childNodeIds = self.getAllChildrenNodeIds(node)

        $.each(childNodeIds,function(index, nodeId){
          RiotControl.trigger("story_remove",nodeId)
        })
        $('.book-tree').tree("removeNode",node);
        RiotControl.trigger("book_link_update",bookTree.tree("getTree").getData())
      }
      RiotControl.trigger("book_selected",null)
    })
    RiotControl.on('story_removed',function(story_id){
      var node = bookTree.tree("getNodeById",story_id);
      if(node){
        var childNodeIds = self.getAllChildrenNodeIds(node)

        $.each(childNodeIds,function(index, nodeId){
          RiotControl.trigger("story_remove",nodeId)
        })
        $('.book-tree').tree("removeNode",node);
        RiotControl.trigger("book_link_update",bookTree.tree("getTree").getData())
      }
      RiotControl.trigger("book_selected",null)
    })
    RiotControl.on('story_added',function(parent_id, parent_type, story){
      if(parent_type == "book")
        parent_id = 'book'+parent_id;
      var parentNode = bookTree.tree('getNodeById', parent_id);
      bookTree.tree('appendNode',{id: story._id,name: story.name, type:"story"},parentNode);
      RiotControl.trigger("book_link_update",bookTree.tree("getTree").getData())

      var node = bookTree.tree("getNodeById", story._id)
      bookTree.tree('selectNode', node);
      self.selectItem(node)
      setTimeout(function(){
        RiotControl.trigger("card_do_add")
      },200)
    })
    RiotControl.on('memo_added',function(parent_id, parent_type, memo){
      if(parent_type == "book")
        parent_id = 'book'+parent_id;
      var parentNode = bookTree.tree('getNodeById', parent_id);
      bookTree.tree('appendNode',{id: memo._id,name: memo.name, type: "memo"},parentNode);
      RiotControl.trigger("book_link_update",bookTree.tree("getTree").getData())

      var node = bookTree.tree("getNodeById", memo._id)
      bookTree.tree('selectNode', node);
      self.selectItem(node)
      setTimeout(function(){
        RiotControl.trigger("memo_item_do_add")
      },200)
    })
    RiotControl.on('map_added',function(parent_id, parent_type, map){
      if(parent_type == "book")
        parent_id = 'book'+parent_id;
      var parentNode = bookTree.tree('getNodeById', parent_id);
      bookTree.tree('appendNode',{id: map._id,name: map.name, type: "map"},parentNode);
      RiotControl.trigger("book_link_update",bookTree.tree("getTree").getData())

      var node = bookTree.tree("getNodeById", map._id)
      bookTree.tree('selectNode', node);
      self.selectItem(node)
      setTimeout(function(){
        RiotControl.trigger("map_item_do_add")
      },200)
    })
    RiotControl.on('story_selected',function(story){
      var node = bookTree.tree("getNodeById",story._id);
      bookTree.tree('selectNode', node);
    })
    RiotControl.on('memo_selected',function(memo){
      var node = bookTree.tree("getNodeById",memo._id);
      bookTree.tree('selectNode', node);
    })
    RiotControl.on('map_selected',function(map){
      var node = bookTree.tree("getNodeById",map._id);
      bookTree.tree('selectNode', node);
    })
    RiotControl.on('book_selected',function(book){
      if(book){
        var node = bookTree.tree("getNodeById","book"+book._id);
        bookTree.tree('selectNode', node);
      }
    })
    RiotControl.on('book_added',function(book){
      var parentNode = bookTree.tree('getTree');
      bookTree.tree('appendNode',{id:'book'+book._id, name:book.name, type: "book"},parentNode);
      RiotControl.trigger("book_link_update",bookTree.tree("getTree").getData())
    })
    RiotControl.on('story_updated',function(story){
      var node = bookTree.tree('getNodeById',  story._id);
      if(node && story.name !== node.name){
        bookTree.tree('updateNode',  node, story.name);
        RiotControl.trigger("book_link_update",bookTree.tree("getTree").getData())
      }
    })
    RiotControl.on('memo_updated',function(memo){
      var node = bookTree.tree('getNodeById',  memo._id);
      if(node && memo.name !== node.name){
        bookTree.tree('updateNode',  node, memo.name);
        RiotControl.trigger("book_link_update",bookTree.tree("getTree").getData())
      }
    })
    RiotControl.on('map_updated',function(map){
      var node = bookTree.tree('getNodeById',  map._id);
      if(node && map.name !== node.name){
        bookTree.tree('updateNode',  node, map.name);
        RiotControl.trigger("book_link_update",bookTree.tree("getTree").getData())
      }
    })
    RiotControl.on('book_updated',function(book){
      var node = bookTree.tree('getNodeById', "book"+book._id);
      if(node && book.name !== node.name){
        bookTree.tree('updateNode',  node, book.name);
        RiotControl.trigger("book_link_update",bookTree.tree("getTree").getData())
      }
    })
    self.on('mount',function(){
      RiotControl.trigger('books_init');
    })
    selectItem(node){
      if(node.id.toString().indexOf("book")>=0)
        RiotControl.trigger('book_select',node.id.replace("book",""))
      else {
        var bookNode = node.parent;
        while(bookNode.getLevel() > 1){
          bookNode = bookNode.parent;
        }
        RiotControl.trigger('story_select',
          node.id,
          bookNode.id.replace("book",""))
      }
    }
    RiotControl.on("parent_book_get",function(story_id){
      var bookId = null;
      var node = bookTree.tree('getNodeById', story_id);
      if(node){
        var bookNode = node.parent;
        while(bookNode.getLevel() > 1){
          bookNode = bookNode.parent;
        }
        bookId = bookNode.id.replace("book","")
      }
      RiotControl.trigger("parent_book_got",bookId)
    })
    delete(e){
      if(bookTree.tree("getSelectedNode"))
        self.mountDialog("confirm-dialog",{
          message: self.getLangText("msg_sure_to_delete"),
          doOK: function(){
            RiotControl.trigger('book_remove');
          }
        })
      else if(self.hasBook())
        self.mountDialog("alert-dialog",{
            message: self.getLangText("please_select_a_book")
        })
      else
        self.mountDialog("alert-dialog",{
          message: self.getLangText("msg_sure_to_add_book")
        })
    }
    add_story(e){
      if(bookTree.tree("getSelectedNode"))
        self.mountDialog("add-page-dialog")
      else
        if(self.hasBook())
          self.mountDialog("alert-dialog",{
            message: self.getLangText("please_select_a_book")
          })
        else
          self.mountDialog("alert-dialog",{
            message: self.getLangText("msg_sure_to_add_book")
          })
    }
    copyTree(node, isTreeCopy){
      var ids = isTreeCopy?self.getAllChildrenNodeIds(node):[]
      var tree = node.getData(true)[0]

      delete tree.is_open
      if(!isTreeCopy) //not children copy, delete children item
        delete tree.children

      ids.push(node.id)
      RiotControl.one("data_copied", function(tree){
        bookTree.tree("addNodeAfter", tree, node)
        RiotControl.trigger("book_link_update",bookTree.tree("getTree").getData())
        RiotControl.trigger("progress_finish")
      })
      RiotControl.trigger("data_copy", {
        ids:ids,
        tree: tree
      })
      RiotControl.trigger("progress_start")
    }
    RiotControl.on("tree-copy-confirmed", function(isTreeCopy){
      self.copyTree(bookTree.tree("getSelectedNode"), isTreeCopy)
    })
    copy(e){
      var node
      if(node = bookTree.tree("getSelectedNode")){
        if(node.children.length > 0)
          self.mountDialog("tree-copy-confirm-dialog")
        else
          self.copyTree(node, false)
      }
      else
        self.mountDialog("alert-dialog",{
          message: self.getLangText("msg_sure_to_add_book_story")
        })
    }
    add_book(e){
      RiotControl.trigger('book_add');
    }
    hasBook(){
      return bookTree.tree("getTree").children.length > 0
    }
    getTreeData(books, stories, parent_id, type){
      var result = [];
      if(!parent_id)
        $.each(books, function(index,book){
          result.push({id:"book"+book.id, name: book.name,
            children: self.getTreeData(books, stories, book.id, "book")})
        })
      else
        $.each(stories, function(index,story){
          if(story.parent_type == type && story.parent_id == parent_id)
            result.push({id:story.id, name: story.name,
              children: self.getTreeData(books, stories, story.id, "story")})
        })
      return result;
    }
    toggleSidePanel(e){
      var $el = $(e.currentTarget)
      var status = $el.data("status")
      if(status == "closed"){
        $el.data("status","opening")
        $('sidemenu-panel').animate({"margin-left":0});
        $('maincontent-panel').animate({width:"73vw"});
        $el.find("i").text("keyboard_arrow_left");
      }
      else{
        $el.data("status","closed")
        $('sidemenu-panel').animate({"margin-left":"-25vw"});
        $('maincontent-panel').animate({width:"100vw"});
        $el.find("i").text("keyboard_arrow_right");
      }
    }
  </script>
</sidemenu-panel>
