<!--
- show story content
- @copyright VTM Corp 2016
-->
<story>
  <div class="row">
    <div class="col s8">
      <b><input type="text" name="title" class="story_title tooltipped" onkeyup={ changeTitle }
          data-position="bottom" data-tooltip={ getLangText("tt_story_name") }></b>
    </div>
  </div>
  <div class="card-list" style="padding-top: 15px">
    <ol class="vertical spare-for-index">
      <li each={ card, card_index in storyDetailData.cards } data-position={ card_index } class="card-elm">
        <div class={ card-item-wrapper:true, active: parent.selectingCardIndex==card_index } onclick={ parent.selectCard }>
          <label class="card-order">{ card_index+1 }</label>
          <div class="card-item">
            <card data={ card } ondblclick={ editCard }></card>
            <div class="group-action tooltipped" data-position="bottom" data-tooltip={ getLangText("tt_story_menu") }>
              <a class={btn-floating:true, btn-large:true, lighten-1:true, btn-action-door:true, grey:!card.links||card.links.length<=0, blue:card.links.length>0 }>
                <i class="large material-icons">
                  more_vert</i>
              </a>
              <ul>
                <li><a class="btn green" onclick={ removeCard }><i class="material-icons">delete</i></a><label>{ getLangText("remove") }</label></li>
                <li><a class="btn blue" onclick={ editCard }><i class="material-icons">mode_edit</i></a><label>{ getLangText("edit") }</label></li>
                <li><a class="btn yellow darken-1" onclick={ addLink }><i class="material-icons">link</i></a><label>{ getLangText("link") }</label></li>
                <li show={ card.links.length > 0 }>
                  <a class="btn lighten-2 blue" onclick={ openLinkDialog }>
                    <i class="material-icons">trending_flat</i>
                  </a>
                  <label>{ getLangText("linkto") }</label>
                </li>
              </ul>
            </div>
          </div>
          <div class="card-description desc1 tooltipped show-scroll" ondblclick={ editDescription }
            data-position="top" data-tooltip={ getLangText("tt_story_description") }>
            <rtf-content class="content-wrapper" content={ formatText(card.description1) } ></rtf-content>
            <div class="overlay-panel"></div>
          </div>
          <div class="card-description desc2 tooltipped show-scroll" ondblclick={ editDescription }
            data-position="top" data-tooltip={ getLangText("tt_story_description") }>
            <rtf-content class="content-wrapper" content={ formatText(card.description2) } ></rtf-content>
            <div class="overlay-panel"></div>
          </div>
        </div>
      </li>
    </ol>
  </div>
  <div class="story-description-wrapper description tooltipped show-scroll" ondblclick={ editDescription }
    data-position="top" data-tooltip={ getLangText("tt_story_memo") }>
    <rtf-content content={ formatText(storyDetailData.description) } ></rtf-content>
    <div class="overlay-panel"></div>
  </div><div class="clearfix"></div>
  <a href="#" class="btn-card-add btn-floating waves-effect btn-large red tooltipped" onclick={ addCard2 }
    data-position="top" data-tooltip={ getLangText("tt_story_add") }>
    <i class="material-icons">add</i></a>
  </div>
  <div class="card-number tooltipped" data-position="bottom" data-tooltip={ getLangText("tt_story_page") }>
    { getLangText("card_number",[storyDetailData.cards.length]) }
  </div>

  <script>
    require('jquery-sortable')
    var self = this
    self.storyDetailData = null
    self.selectingCardIndex = 0

    self.on("update",function(){
      if(self.opts.type == "story"){ //specify filter, due to riot bug which conditionals attributes on custom nested tags does not stop riot from evaluating the hidden expressions
        self.storyDetailData = self.opts.story;
      }
    })
    self.on("updated",function(){
      self.initTooltip()
      if(self.storyDetailData) $('.story_title').val(self.storyDetailData.name);
      $('.card-list > ol').sortable({
          itemSelector: ".card-elm",
          onDragStart: function($item, container, _super, event){
            $item.css({
              height: $item.outerHeight(),
              width: $item.outerWidth()
            })
            $item.addClass(container.group.options.draggedClass)
            $("body").addClass(container.group.options.bodyClass)

            $(".description .overlay-panel, \
                .card-description .overlay-panel").show()
          },
          onDrop: function ($item, container, _super, event) {
            $item.removeClass(container.group.options.draggedClass).removeAttr("style")
            $("body").removeClass(container.group.options.bodyClass)

            var new_card_list = []
            container.el.find("> li").each(function(){
              new_card_list.push(self.storyDetailData.cards[$(this).data("position")])
              $(this).data("position",new_card_list.length - 1)
              if($(this).find(".card-item-wrapper").hasClass("active"))
                self.selectingCardIndex = new_card_list.length - 1
            })
            self.storyDetailData.cards = new_card_list
            RiotControl.trigger('story_update',self.storyDetailData)

            $(".description .overlay-panel, \
                .card-description .overlay-panel").hide()
            self.update()
          }
      })
      $(".group-action .btn-action-door,.group-action ul")
        .on("mouseenter",function(){
          var $elm = $(this).closest(".group-action")
          $elm.find("ul").stop(true, false).slideDown();
        })
        .on("mouseleave",function(){
          var $elm = $(this).closest(".group-action");
            $elm.find("ul").stop(true, false).slideUp()
        })
    })
    doCardAdd(){
      RiotControl.off("card_add")
      RiotControl.one("card_add", function(card){
        self.storyDetailData.cards.splice(self.selectingCardIndex+1,0,card)
        if(self.storyDetailData.cards.length > 1)
          self.selectingCardIndex++
        else
          self.selectingCardIndex = 0
        RiotControl.trigger('story_update',self.storyDetailData)
        self.update()
      })
      self.mountDialog("card-add-dialog", {type: "story"})
    }
    RiotControl.on("card_do_add", function(){
      if($("story").length > 0 && self.storyDetailData)
        self.doCardAdd()
    })
    RiotControl.on("link_do_add",function(){
      if($("story").length > 0 && self.storyDetailData &&
        self.selectingCardIndex < self.storyDetailData.cards.length){
        self.doAddLink(self.storyDetailData.cards[self.selectingCardIndex])
      }
    })
    formatText(text){
      return text?text:"";
    }
    changeTitle(e){
      self.storyDetailData.name = $(e.currentTarget).val()
      RiotControl.trigger("story_update", self.storyDetailData)
      e.preventUpdate = true
    }
    changeDescription(e){
      self.storyDetailData.description = $(e.currentTarget).val()
      RiotControl.trigger("story_update", self.storyDetailData)
    }
    editCard(e){
      RiotControl.off("card_update")
      RiotControl.one("card_update", self.doUpdateCard)
      var card = e.item.card
      self.mountDialog("card-edit-dialog",{card:card})
    }
    addCard(e){
        self.doCardAdd()
    }
    addCard2(e){
        self.doCardAdd()
    }
    doUpdateCard(card){
      self.storyDetailData.cards[self.selectingCardIndex] = $.extend(true,{},card)
      RiotControl.trigger('story_update',self.storyDetailData)
      self.update()
    }
    doAddLink(card){
      RiotControl.off("card_update")
      RiotControl.one("card_update", self.doUpdateCard)
      self.mountDialog("link-add-dialog",{card:card, story: self.storyDetailData})
    }
    addLink(e){
      self.doAddLink(e.item.card)
    }
    removeCard(e){
      self.mountDialog("confirm-dialog",{
        message: self.getLangText("msg_sure_to_delete"),
        doOK: function(){
          var card_index = e.item.card_index
          self.storyDetailData.cards.splice(card_index,1)
          if(self.storyDetailData.cards.length+1 > card_index)
            self.selectingCardIndex = card_index
          else
            self.selectingCardIndex = card_index-1

          if(self.storyDetailData.cards.length <= self.selectingCardIndex)
            self.selectingCardIndex = self.storyDetailData.cards.length-1
          if(self.selectingCardIndex < 0)
            self.selectingCardIndex = 0
          RiotControl.trigger('story_update',self.storyDetailData)
          self.update()
        }
      })
    }
    openLinkDialog(e){
      var card = e.item.card
      if(card.links.length == 1)
        RiotControl.trigger('story_select',card.links[0],null)
      else
        self.mountDialog("link-dialog",{card:card})
    }
    selectCard(e){
      var $this = $(e.srcElement)
      var card = self.storyDetailData.cards[e.item.card_index]
      self.selectingCardIndex = e.item.card_index
    }
    editDescription(e){
      var descElm = $(e.currentTarget)
      if(descElm.length > 0){
        if(descElm.is(".desc1")){
          type = "desc1"
          content= e.item.card.description1
        }
        else if(descElm.is(".desc2")){
          type = "desc2"
          content= e.item.card.description2
        }
        else if(descElm.is(".description")){
          type = "description"
          content= self.storyDetailData.description
        }
        self.updateDescription(type, content)
      }
    }
    updateDescription(type, content){
      RiotControl.off("richtext_updated")
      RiotControl.one("richtext_updated",function(data){
        if(data.type == "description"){
          self.storyDetailData.description = data.content
          RiotControl.trigger('story_update',self.storyDetailData)
          self.update()
        }

        if(self.selectingCardIndex < 0 || self.selectingCardIndex >= self.storyDetailData.cards.length)
          return;

        var card = self.storyDetailData.cards[self.selectingCardIndex];
        switch (data.type) {
          case "desc1":
            card.description1 = data.content
            break;
          case "desc2":
            card.description2 = data.content
            break;
          default:
        }
        RiotControl.trigger('story_update',self.storyDetailData)
        self.update()
      })
      self.mountDialog("richtext-dialog",{content:content, type: type})
    }
  </script>
</story>
